﻿EToyCommunicatorMorph subclass: #Alumno
	instanceVariableNames: ''
	classVariableNames: 'GlobalIncomingQueue GlobalListener QueueSemaphore UpdateCounter WasListeningAtShutdown'
	poolDictionaries: ''
	category: 'Classroom'!

!Alumno methodsFor: 'initialization' stamp: 'jlrr 5/18/2005 17:40'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color paleYellow! !

!Alumno methodsFor: 'initialization' stamp: 'jlrr 5/12/2005 10:24'!
initialize
	super initialize.
	"To avoid appearing of login message:"
Utilities authorName:'Teacher'.
""
	self class startListening.
	! !


!Alumno methodsFor: 'private' stamp: 'jlrr 5/13/2005 18:27'!
registerInTeacher
	| teacher sender outData myAddress |
	teacher := FillInTheBlank request: 'Teacher''s computer name or network address?:' translated initialAnswer: '192.168.0.20'.
	teacher isEmpty
		ifFalse: [myAddress := NetNameResolver stringFromAddress: NetNameResolver localHostAddress.
			myAddress = '127.0.0.1'
				ifTrue: [myAddress := self class debianAddress].
			sender := EToySenderMorph new.
			outData := myAddress asMorph eToyStreamedRepresentationNotifying: sender.
			"sender transmitStreamedObject: outData to: teacher."
			sender
				transmitStreamedObject: outData
				as: 'typeAddress'
				to: teacher.
			sender delete]! !

!Alumno methodsFor: 'private' stamp: 'jlrr 5/18/2005 18:25'!
registerInTeacher: aString 
	"little trick to launch the student from a flap"
	^ self registerInTeacher.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Alumno class
	instanceVariableNames: ''!

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
addToGlobalIncomingQueue: aMorphTuple

	self critical: [
		self globalIncomingQueue add: aMorphTuple.
		self bumpUpdateCounter.
	].! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
bumpUpdateCounter

	UpdateCounter _ (UpdateCounter ifNil: [0]) + 1.
! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 17:27'!
commResultDeferred: anArrayOfAssociations 
	"to be run as part of the UI process in case user interaction is
	required "
	| m ipAddress aDictionary |
	aDictionary := Dictionary new.
	anArrayOfAssociations
		do: [:each | aDictionary add: each].
	aDictionary
		at: #commFlash
		ifPresent: [:ignore | ^ self].
	m := aDictionary
				at: #message
				ifAbsent: [^ self].
	m = 'OK'
		ifFalse: [^ self].
	ipAddress := NetNameResolver
				stringFromAddress: (aDictionary at: #ipAddress).
	Receptor new
		incomingMessgage: (ReadStream
				on: (aDictionary at: #data))
		fromIPAddress: ipAddress! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
commResult: anArrayOfAssociations

	WorldState addDeferredUIMessage: [self commResultDeferred: anArrayOfAssociations].! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
confirmListening

	self isListening ifFalse: [
		(self confirm: 'You currently are not listening and will not hear a reply.
Shall I start listening for you?') ifTrue: [
			self startListening
		].
	].
! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
critical: aBlock

	QueueSemaphore ifNil: [QueueSemaphore _ Semaphore forMutualExclusion].
	^QueueSemaphore critical: aBlock
! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 21:32'!
debianAddress
	"This method has been checked only in gnu/Linux Debian
	systems.
	I don't know why, but if the computer address is not written at
	/etc/hosts, NetNameResolver localAddressString fails.
	For this case I have written this method"
	| proceso pipe2 output dest desc tipoOS sentencia resultado |
	sentencia := '/sbin/ifconfig | grep Bcast | cut -f2 -d: | cut -f1 -d" "'.
	OSProcess accessor canAccessSystem
		ifFalse: [^ nil].
	pipe2 := OSPipe nonBlockingPipe.
	output := pipe2 writer.
	dest := pipe2 reader.
	desc := Array
				with: nil
				with: output
				with: nil.
	tipoOS := ExternalOSProcess concreteClass.
	Cursor wait
		showWhile: [tipoOS == ExternalUnixOSProcess
				ifTrue: [proceso := tipoOS
								forkAndExec: tipoOS defaultShellPath
								arguments: (Array with: '-c' with: sentencia)
								environment: nil
								descriptors: desc].
			tipoOS == ExternalWindowsOSProcess
				ifTrue: [proceso := tipoOS commandNoEvaluate: sentencia.
					proceso initialStdOut: output.
					proceso value].
			output close.
			[proceso isComplete]
				whileFalse: [(Delay forSeconds: 0.1) wait].
			resultado := dest upToEnd.
			dest close].
	(resultado at: resultado size)
			= Character lf
		ifTrue: [resultado := resultado copyFrom: 1 to: resultado size - 1].
	^ resultado! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
ensureListenerInCurrentWorld

	| w |
	w _ self currentWorld.
	EToyListenerMorph allInstances 
		detect: [ :each | each world == w]
		ifNone: [EToyListenerMorph new open]! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
flashIndicator: ignoredForNow! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
globalIncomingQueue

	^GlobalIncomingQueue ifNil: [GlobalIncomingQueue _ OrderedCollection new].! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
globalIncomingQueueCopy

	^self critical: [self globalIncomingQueue copy].
! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
isListening

	^GlobalListener notNil
! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
makeListeningToggleNew: activeMode

	| background c baseExtent bgExtent botCent factor len endPts base |

	factor _ 2.
	bgExtent _ (50@25) * factor.
	baseExtent _ (15@15) * factor.
	background _ Form extent: bgExtent depth: 8.
	botCent _ background boundingBox bottomCenter.
	c _ background getCanvas.
"c fillColor: Color white."
	base _  (botCent - (baseExtent // 2)) extent: baseExtent.
	c
		fillOval: base
		color: Color black 
		borderWidth: 0 
		borderColor: Color black.
	activeMode ifTrue: [
		len _ background boundingBox height - 15.
		endPts _ {botCent - (len@len). botCent - (len negated@len)}.
		endPts do: [ :each |
			c line: botCent to: each width: 2 color: Color black.
		].
		endPts do: [ :each |
			#(4 8 12) do: [ :offset |
				c frameOval: (each - offset corner: each + offset) color: Color red
			].
		].
	].
"background asMorph openInWorld."
	^background


	! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
makeListeningToggle: withEars

	| background c capExtent bgExtent earExtent earDeltaX earDeltaY botCent factor parts |

	factor _ 2.
	bgExtent _ (50@25) * factor.
	capExtent _ (30@30) * factor.
	earExtent _ (15@15) * factor.
	earDeltaX _ capExtent x // 2.
	earDeltaY _ capExtent y // 2.
	background _ Form extent: bgExtent depth: 8.
	botCent _ background boundingBox bottomCenter.
	c _ background getCanvas.
	"c fillColor: Color white."
	parts _ {
		(botCent - (capExtent // 2)) extent: capExtent.
	}.
	withEars ifTrue: [
		parts _ parts , {
			(botCent - (earDeltaX @ earDeltaY) - (earExtent // 2)) extent: earExtent.
			(botCent - (earDeltaX negated @ earDeltaY) - (earExtent // 2)) extent: earExtent.
		} 
	].
	parts do: [ :each |
		c
			fillOval: each
			color: Color black 
			borderWidth: 0 
			borderColor: Color black.
	].
	^background

"=====
	f2 _ Form extent: 30@15 depth: 8.
	background displayInterpolatedOn: f2.
	f2 replaceColor: Color white withColor: Color transparent.
	^f2
====="


	! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
removeFromGlobalIncomingQueue: theActualObject

	self critical: [
		GlobalIncomingQueue _ self globalIncomingQueue reject: [ :each | 
			each second == theActualObject
		].
		self bumpUpdateCounter.
	].! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
resetIndicator: ignoredForNow! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
startListening

	self stopListening.
	GlobalListener _ EToyPeerToPeer new awaitDataFor: self.
	self bumpUpdateCounter.

! !

!Alumno class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 16:04'!
stopListening
	GlobalListener ifNotNil:
		[GlobalListener stopListening.
		GlobalListener _ nil.
		self bumpUpdateCounter]

	"EToyListenerMorph stopListening"! !


!Alumno class methodsFor: 'parts bin' stamp: 'jlrr 5/8/2005 16:04'!
descriptionForPartsBin

	^ self partName: 	'Listener'
		categories:		#('Collaborative')
		documentation:	'A tool for receiving things from other Squeak uers'! !


!Alumno class methodsFor: 'class initialization' stamp: 'jlrr 5/8/2005 16:04'!
initialize
"
EToyListenerMorph initialize
"
	
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
! !

!Alumno class methodsFor: 'class initialization' stamp: 'jlrr 5/8/2005 16:04'!
unload
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
! !


!Alumno class methodsFor: 'instance creation' stamp: 'jlrr 5/8/2005 19:31'!
nuevo
	| alumno |
	alumno := self new.
alumno registerInTeacher.
	^ alumno! !

!Alumno class methodsFor: 'instance creation' stamp: 'jlrr 5/8/2005 19:31'!
profesor
	| profesor |
	profesor:= self new.
	
	^ profesor! !


!Alumno class methodsFor: 'system startup' stamp: 'jlrr 5/8/2005 16:04'!
shutDown: quitting

	WasListeningAtShutdown _ GlobalListener notNil.
	self stopListening.
! !

!Alumno class methodsFor: 'system startup' stamp: 'jlrr 5/8/2005 16:04'!
startUp: resuming

	WasListeningAtShutdown == true ifTrue: [
		self startListening.
	].
! !


SimpleButtonMorph subclass: #BotonOpciones
	instanceVariableNames: 'seleccionado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!BotonOpciones methodsFor: 'drawing' stamp: 'jlrr 4/7/2005 16:41'!
color: aColor 
	super color: aColor.
	self x color: aColor! !

!BotonOpciones methodsFor: 'drawing' stamp: 'jlrr 4/7/2005 16:40'!
drawOn: aCanvas 
	aCanvas frameRectangle: (self x bounds expandBy: 1 @ 1)
		color: Color black! !

!BotonOpciones methodsFor: 'drawing' stamp: 'jlrr 4/7/2005 21:06'!
ponerX
	| morph |
	morph := self x.
	morph submorphs do: [:each | each show]! !

!BotonOpciones methodsFor: 'drawing' stamp: 'jlrr 4/7/2005 21:06'!
quitarX
	| morph |
	morph := self x.
	morph submorphs do: [:each | each hide]! !


!BotonOpciones methodsFor: 'geometry' stamp: 'jlrr 4/7/2005 16:44'!
extent: aPoint 
	bounds extent = aPoint 
		ifFalse: 
			[self changed.
		
			bounds := bounds topLeft extent: (aPoint max: self x extent + (2 @ 2)).
			self layoutChanged.
			self changed]! !


!BotonOpciones methodsFor: 'initialization' stamp: 'jlrr 4/7/2005 18:43'!
initialize
	| rect x |
	submorphs := EmptyArray.
	bounds := 0 @ 0 corner: 10 @ 10.
	self borderWidth: 0.
	target := nil.
	actionSelector := #check:.
	arguments := Array new: 1.
	actWhen := #buttonUp.
	rect := RectangleMorph new extent: 16 @ 16.
	rect position: 1 @ 1.
	rect borderWidth: 2.
	rect borderColor: #raised.
	self addMorph: rect.
	rect lock.
	x := (RectangleMorph new)
				borderWidth: 3;
				borderColor: #complexInset;
				extent: 10 @ 10;
				position: 4 @ 4;
				color: Color blue.
	rect addMorph: x.
	x lock.
	x hide.
	seleccionado := false.
	self color: Color veryLightGray lighter.
	self label:''! !


!BotonOpciones methodsFor: 'event handling' stamp: 'jlrr 4/7/2005 16:50'!
mouseUp: evt 
	oldColor ifNotNil: 
			["esta comprobaciÛn de oldColor es para evitar que sea active si el botÛn est· siendo 'dragueado'"

			self color: oldColor.
			oldColor := nil.
			self x borderColor: #raised.
			(self containsPoint: evt cursorPoint) 
				ifTrue: 
					[seleccionado := seleccionado not.
					seleccionado ifTrue: [self ponerX] ifFalse: [self quitarX]].
			arguments at: 1 put: seleccionado.
			(actWhen == #buttonUp and: [self containsPoint: evt cursorPoint]) 
				ifTrue: [self doButtonAction]]! !


!BotonOpciones methodsFor: 'accesing' stamp: 'jlrr 4/7/2005 18:46'!
seleccionado
^seleccionado! !

!BotonOpciones methodsFor: 'accesing' stamp: 'jlrr 4/7/2005 16:39'!
x
^self findA:RectangleMorph! !


NCAAConnectorMorph subclass: #ConexionPareja
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!ConexionPareja methodsFor: 'protected-policy' stamp: 'jlrr 3/31/2005 19:07'!
wantsToAttachEnd: index toMorph: aMorph 
	
	^aMorph class = ElementoParejas ! !


TextMorphEditor subclass: #EjercicioHuecosEditor
	instanceVariableNames: 'huecando puntoHueco generador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!EjercicioHuecosEditor methodsFor: 'as yet unclassified' stamp: 'jlrr 4/27/2005 12:54'!
bounds
	
	^ morph bounds! !

!EjercicioHuecosEditor methodsFor: 'as yet unclassified' stamp: 'jlrr 4/28/2005 19:35'!
mouseDown: evt 
	"An attempt to break up the old processRedButton code into
	threee phases"
	| clickPoint bloqueActual kk |
	oldInterval := self selectionInterval.
	clickPoint := evt cursorPoint.
	pivotBlock
		ifNotNil: [bloqueActual := paragraph characterBlockAtPoint: clickPoint.
			huecando := false.
			self morph locked
				ifFalse: [kk := paragraph selectionRects.
					kk
						collect: [:each | (each intersects: bloqueActual)
								ifTrue: [huecando := true]].
					huecando
						ifTrue: [^ self selection]]].
	(paragraph
			clickAt: clickPoint
			for: model
			controller: self)
		ifTrue: [pivotBlock := paragraph characterBlockAtPoint: clickPoint.
			self markBlock: pivotBlock.
			self pointBlock: pivotBlock.
			evt hand releaseKeyboardFocus: self.
			^ self].
	evt shiftPressed
		ifTrue: [self closeTypeIn.
			self mouseMove: evt]
		ifFalse: [self closeTypeIn.
			pivotBlock := paragraph characterBlockAtPoint: clickPoint.
			self markBlock: pivotBlock.
			self pointBlock: pivotBlock].
	self storeSelectionInParagraph! !

!EjercicioHuecosEditor methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 12:52'!
mouseMove: evt 
	"Change the selection in response to moue-down drag"
	| passenger ddm hueco |
	pivotBlock
		ifNil: [^ self].
	huecando
		ifTrue: [[passenger := Hueco new label: self selection;
						 comienzo: self startIndex;
						 fin: self stopIndex;
						 textPosition: paragraph selectionRects first origin + (0 @ 2).
			hueco := passenger copy 
						 receptor: self morph;
						 pareja: passenger;
						 position: passenger textPosition;
borderWidth: 0;
						 label: passenger label;
						 removeBold.
			self morph addMorphFront: hueco.
			ddm := TransferMorph withPassenger: passenger from: self.
			ddm dragTransferType: #hueco.
			ddm dropNotifyRecipient: hueco.
			TransferMorphLineAnimation on: ddm.
			evt hand grabMorph: ddm]
				ensure: [Cursor normal show.
					evt hand releaseMouseFocus: self]]
		ifFalse: ["Patched during clickAt: repair"
			self
				pointBlock: (paragraph characterBlockAtPoint: evt cursorPoint).
			self storeSelectionInParagraph]! !

!EjercicioHuecosEditor methodsFor: 'as yet unclassified' stamp: 'jlrr 4/26/2005 21:49'!
mouseUp: evt 
	"An attempt to break up the old processRedButton code into
	threee phases"
	oldInterval
		ifNil: [^ self].
	
	"Patched during clickAt: repair"
	(self hasCaret
			and: [oldInterval = self selectionInterval])
		ifTrue: [self selectWord].
	self setEmphasisHere.
	(self isDisjointFrom: oldInterval)
		ifTrue: [otherInterval := oldInterval].
	self storeSelectionInParagraph! !


!EjercicioHuecosEditor methodsFor: 'initialization' stamp: 'jlrr 4/28/2005 19:32'!
initialize
	super initialize.
	huecando := false.
generador:=true.! !


BasicButton subclass: #ElementoParejas
	instanceVariableNames: 'texto conector elementoConectado pareja lado'
	classVariableNames: 'Colors LastColorIndex'
	poolDictionaries: ''
	category: 'Classroom'!

!ElementoParejas methodsFor: 'event handling' stamp: 'jlrr 3/20/2005 17:46'!
connectedToBy: aConnector 
	| origen destino |
	conector := aConnector.
	origen := conector sourceMorph.
	destino := conector destinationMorph.
	origen notNil & destino notNil 
		ifTrue: 
			[self siguienteColor.
			conector color: (Colors at: LastColorIndex).
			self = origen 
				ifFalse: 
					
							[self elementoConectado: origen.
							origen elementoConectado: self color: (Colors at: LastColorIndex)]
				ifTrue:
							[self elementoConectado: destino.
							destino elementoConectado: self color: (Colors at: LastColorIndex)]]! !

!ElementoParejas methodsFor: 'event handling' stamp: 'jlrr 3/20/2005 16:16'!
disconnectedFromBy: aConnector 
	"notification upon disconnection by a NCConnectorMorph"

	conector := nil.
elementoConectado:=nil.! !

!ElementoParejas methodsFor: 'event handling' stamp: 'jlrr 3/20/2005 12:34'!
handlesMouseDown: evt 
	^evt shiftPressed not! !

!ElementoParejas methodsFor: 'event handling' stamp: 'jlrr 3/20/2005 12:35'!
mouseDown: evt 
	super mouseDown: evt.
	evt yellowButtonPressed 
		ifFalse: 
			[self outgoingConnectionCount = 0 & (self incomingConnectionCount = 0) 
				ifTrue: [self startWiring]]! !

!ElementoParejas methodsFor: 'event handling' stamp: 'jlrr 5/12/2005 10:19'!
startWiring
	ConexionPareja newCurvyArrow startWiringFrom: self! !


!ElementoParejas methodsFor: 'initialization' stamp: 'jlrr 3/20/2005 12:53'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 0! !

!ElementoParejas methodsFor: 'initialization' stamp: 'jlrr 3/20/2005 11:01'!
defaultColor
"answer the default color/fill style for the receiver"
	^ Color blue alpha: 0.4! !

!ElementoParejas methodsFor: 'initialization' stamp: 'jlrr 3/23/2005 18:08'!
initialize
	super initialize.
	self defaultColor.
self useSquareCorners.
self borderWidth:2.
	self borderColor: Color transparent.
! !


!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/20/2005 16:24'!
elementoConectado
	^elementoConectado! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/20/2005 17:41'!
elementoConectado: anObject 

	self elementoConectado: anObject color: (Colors at: LastColorIndex)! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/20/2005 17:25'!
elementoConectado: anObject color: aColor 
	elementoConectado := anObject.

	self color: aColor! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/22/2005 17:23'!
lado
^lado! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/22/2005 17:23'!
lado: aString 
	lado:=aString! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/22/2005 17:23'!
pareja
^pareja! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/22/2005 17:55'!
pareja: aElementoPareja 
	pareja := aElementoPareja.

	aElementoPareja pareja = self ifFalse: [aElementoPareja pareja: self]! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/30/2005 22:13'!
texto
	^texto! !

!ElementoParejas methodsFor: 'accesing' stamp: 'jlrr 3/20/2005 12:34'!
texto: aStringOrText 
	| |
	texto := aStringOrText.
	self label: aStringOrText
! !


!ElementoParejas methodsFor: 'comparing' stamp: 'jlrr 3/22/2005 18:03'!
hacePareja: aElementoParejas 
	^aElementoParejas  = self pareja ! !


!ElementoParejas methodsFor: 'private' stamp: 'jlrr 3/20/2005 17:40'!
siguienteColor
	" Use the next color in the standard sequence."

	Colors ifNil: [self class initialize].
	LastColorIndex := LastColorIndex ifNil: [1]
				ifNotNil: [LastColorIndex \\ Colors size + 1].
	! !

!ElementoParejas methodsFor: 'private' stamp: 'jlrr 5/12/2005 17:30'!
wantsAttachmentFromEnd: endIndex ofConnector: aConnector 
	^ aConnector sourceMorph class = self class! !

!ElementoParejas methodsFor: 'private' stamp: 'jlrr 5/12/2005 17:30'!
wantsConnectionWhenEmbedded
	^ true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ElementoParejas class
	instanceVariableNames: ''!

!ElementoParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/22/2005 12:29'!
conTexto:aStringOrText
| elemento |
elemento:= self new.
elemento texto:aStringOrText.
^elemento! !

!ElementoParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/22/2005 17:28'!
conTexto: aStringOrText lado:aString
	| elemento |
	elemento := self new.
	elemento texto: aStringOrText.
	elemento lado:aString.
	^elemento! !

!ElementoParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/22/2005 17:30'!
derecho: aStringOrText izquierdo: anotherStringOrText
	| elementoDerecho elementoIzquierdo |
	elementoDerecho  := self new.
	elementoDerecho  texto: aStringOrText.
	elementoDerecho  lado: 'derecho'.
	elementoIzquierdo  := self new.
	elementoIzquierdo  texto: anotherStringOrText.
	elementoIzquierdo  lado: 'izquierdo'.
elementoDerecho pareja:elementoIzquierdo.




	^elementoDerecho! !

!ElementoParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/20/2005 17:18'!
initialize

	LastColorIndex := 0.
	Colors :=  {
		TranslucentColor r: 0.0 g: 0.0 b: 0.839 alpha: 0.267.
		TranslucentColor r: 0.484 g: 1.0 b: 0.452 alpha: 0.706.
		TranslucentColor r: 1.0 g: 0.355 b: 0.71 alpha: 0.569.
		TranslucentColor r: 1.0 g: 1.0 b: 0.03 alpha: 0.561.
		TranslucentColor r: 0.484 g: 0.161 b: 1.0 alpha: 0.529.
		TranslucentColor r: 0.097 g: 0.097 b: 0.097 alpha: 0.192.
	}.
	! !

!ElementoParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/22/2005 19:41'!
izquierdo: aStringOrText derecho: anotherStringOrText 
	| elementoDerecho elementoIzquierdo |
	elementoDerecho := self new.
	elementoDerecho texto: anotherStringOrText.
	elementoDerecho lado: 'derecho'.
	elementoIzquierdo := self new.
	elementoIzquierdo texto: aStringOrText.
	elementoIzquierdo lado: 'izquierdo'.
	elementoDerecho pareja: elementoIzquierdo.
	^elementoIzquierdo! !


FileList2 subclass: #FileDialog
	instanceVariableNames: 'salida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!FileDialog methodsFor: 'gui' stamp: 'jlrr 5/18/2005 20:06'!
construyeInterfaz
	| window buttons treePane textColor1 fileListPane pane2a pane2b treeExtent filesExtent |
	window := PanelEjercicios newColumn.
	window hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	textColor1 := Color
				r: 0.742
				g: 0.839
				b: 1.0.
	window setProperty: #FileList toValue: self;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 borderWidth: 2;
		
		borderColor: (Color
				r: 0.0
				g: 0.4
				b: 0.8);
		 useRoundedCorners.
	buttons := {{'OK' translated. Color green}. {'Cancel' translated. Color red}}
				collect: [:each | (SimpleButtonMorph newWithLabel: each first) extent: 100 @ 40;
						 borderColor: Color black;
						 color: each second].
	World width < 800
		ifTrue: [treeExtent := 150 @ 300.
			filesExtent := 350 @ 300]
		ifFalse: [treeExtent := 250 @ 300.
			filesExtent := 350 @ 300].
	(treePane := self morphicDirectoryTreePaneFiltered: #initialDirectoryList) extent: treeExtent;
		 retractable: false;
		 borderWidth: 0.
	fileListPane := self morphicFileListPane extent: filesExtent;
				 retractable: false;
				 borderWidth: 0.
	window addARow: {window
			fancyText: 'Load an exercise' translated
			font: (Preferences standardEToysFont pixelSize: 14)
			color: textColor1};
		 addARowCentered: {buttons first. (Morph new extent: 30 @ 5)
			color: Color transparent. buttons second};
		 addARow: {window
			fancyText: 'Please, select an exercise' translated
			font: Preferences standardEToysFont
			color: textColor1};
		 addARow: {(window inAColumn: {(pane2a := window inARow: {window inAColumn: {treePane}}) useRoundedCorners; layoutInset: 0; borderWidth: 1;
				borderColor: (Color
						r: 1.0
						g: 0.8
						b: 0.0)})
			layoutInset: 10. (window inAColumn: {(pane2b := window inARow: {window inAColumn: {fileListPane}}) useRoundedCorners; layoutInset: 0; borderWidth: 1;
				borderColor: (Color
						r: 1.0
						g: 0.8
						b: 0.0)})
			layoutInset: 10}.
	window fullBounds.
	window color: Color lightYellow.
	pane2a color: Color lightYellow.
	pane2b color: Color lightYellow.
	""
	buttons first
		on: #mouseUp
		send: #okHit
		to: self.
	buttons second
		on: #mouseUp
		send: #cancelHit
		to: self.
	window position: World topLeft + (World extent - window extent // 2).
	window
		adoptPaneColor: (Color
				r: 0.548
				g: 0.677
				b: 1.0).
	^ window openInWorld: World! !

!FileDialog methodsFor: 'gui' stamp: 'jlrr 5/11/2005 16:31'!
construyeInterfazDirectorios
	| window buttons treePane textColor1 pane2a treeExtent |
	window := PanelEjercicios newColumn.
	window hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	textColor1 := Color
				r: 0.742
				g: 0.839
				b: 1.0.
	window setProperty: #FileList toValue: self;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 borderWidth: 2;
		
		borderColor: (Color
				r: 0.0
				g: 0.4
				b: 0.8);
		 useRoundedCorners.
	buttons := {{'OK' translated. Color green}. {'Cancel' translated. Color red}}
				collect: [:each | window
						createBoton: each
						accion: nil
						textColor: textColor1].
	World width < 800
		ifTrue: [treeExtent := 150 @ 300]
		ifFalse: [treeExtent := 250 @ 300].
	(treePane := self morphicDirectoryTreePaneFiltered: #initialDirectoryList) extent: treeExtent;
		 retractable: false;
		 borderWidth: 0.
	window addARow: {window
			fancyText: 'Save an exercise' translated
			font: (Preferences standardEToysFont pixelSize: 14)
			color: textColor1};
		 addARowCentered: {buttons first. (Morph new extent: 30 @ 5)
			color: Color transparent. buttons second};
		 addARow: {window
			fancyText: 'Please, select a folder' translated
			font: Preferences standardEToysFont
			color: textColor1};
		 addARow: {(window inAColumn: {(pane2a := window inARow: {window inAColumn: {treePane}}) useRoundedCorners; layoutInset: 0; borderWidth: 1;
				borderColor: (Color
						r: 1.0
						g: 0.8
						b: 0.0)})
			layoutInset: 10}.
	window fullBounds.
	"window fillWithRamp: ColorTheme current
	dialogRampOrColor oriented: 0.65.
	pane2a fillWithRamp: ColorTheme current
	dialogPaneRampOrColor oriented: 0.7 @ 0.35."
	window color: Color lightYellow.
	pane2a color: Color lightYellow.
	""
	buttons first
		on: #mouseUp
		send: #okHit
		to: self.
	buttons second
		on: #mouseUp
		send: #cancelHit
		to: self.
	window position: World topLeft + (World extent - window extent // 2).
	window
		adoptPaneColor: (Color
				r: 0.548
				g: 0.677
				b: 1.0).
	^ window openInWorld: World! !

!FileDialog methodsFor: 'gui' stamp: 'jlrr 5/11/2005 21:56'!
dirSelect

	self
		directory: (FileDirectory on: self directorioLocal);
		optionalButtonSpecs: self servicesForProjectLoader;
		modalView: self construyeInterfazDirectorios.
	self postOpen.
	[modalView world notNil] 
		whileTrue: [modalView outermostWorldMorph doOneCycle].

	^self getSelectedDirectory ! !

!FileDialog methodsFor: 'gui' stamp: 'jlrr 3/28/2005 20:17'!
fileSelect: anArray 
   self 
            directory:(FileDirectory on: self directorioLocal);
		optionalButtonSpecs: self servicesForProjectLoader;
		fileSelectionBlock: (
				self filtroArchivosSelectionBlock:anArray
			
		);

		modalView: self construyeInterfaz.
	

self postOpen.

	
	[modalView world notNil] whileTrue: [
		modalView outermostWorldMorph doOneCycle.
	].
	^self getSelectedFile ! !


!FileDialog methodsFor: 'private' stamp: 'jlrr 3/28/2005 18:35'!
directorioLocal
|directorioSqueak|
directorioSqueak:=FileDirectory default pathName.

^directorioSqueak copyFrom: 1 to:(directorioSqueak findString: '/.squeak').
! !

!FileDialog methodsFor: 'private' stamp: 'jlrr 5/11/2005 21:56'!
getSelectedDirectory
	
	^ directory! !


!FileDialog methodsFor: 'accesing' stamp: 'jlrr 3/28/2005 18:44'!
filtroArchivosSelectionBlock:anArray

	^[ :entry :myPattern |
		entry isDirectory ifTrue: [
			false
		] ifFalse: [
			anArray anySatisfy: [ :each | each match: entry name]
		]
	] fixTemps! !


RectangleMorph subclass: #Hueco
	instanceVariableNames: 'textPosition pareja huecoConectado manejable receptor comienzo fin'
	classVariableNames: 'Colors UltimoColor'
	poolDictionaries: ''
	category: 'Classroom'!

!Hueco methodsFor: 'dropping/grabbing' stamp: 'jlrr 4/28/2005 19:17'!
acceptDroppingMorph: aHueco event: evt 
	| success |
	success := aHueco class = Hueco
				ifTrue: [aHueco position: self position].
	^ success! !

!Hueco methodsFor: 'dropping/grabbing' stamp: 'jlrr 4/28/2005 21:05'!
justDroppedInto: aMorph event: anEvent 
	aMorph class = Hueco
		ifTrue: [self position: aMorph position.
			aMorph owner addMorph: self.
			aMorph huecoConectado: self.
			self huecoConectado: aMorph.
			self opaco]
		ifFalse: [aMorph class=TrashCanMorph ifFalse:[
			receptor addMorph: self.
			self position: receptor position + textPosition]]! !


!Hueco methodsFor: 'accessing' stamp: 'jlrr 5/4/2005 18:53'!
comienzo
^comienzo! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 5/4/2005 18:53'!
comienzo:anInteger
comienzo:=anInteger! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 5/4/2005 18:53'!
fin
^fin! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 5/4/2005 18:53'!
fin:anInteger
fin:=anInteger.! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 20:24'!
huecoConectado
	^huecoConectado ! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 20:24'!
huecoConectado:aHueco
huecoConectado:=aHueco! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 17:22'!
label
	^ (self findA: StringMorph) contents! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 5/7/2005 12:53'!
label: aString 
	| oldLabel m |
	(oldLabel := self findA: StringMorph)
		ifNotNil: [oldLabel delete].
	m := StringMorph contents: aString font: TextStyle defaultFont.
	m emphasis: 1.
	self extent: m extent.
	borderWidth > 0
		ifTrue: [self extent: m extent + borderWidth + (1 @ 1)]
		"ifFalse: [self extent: m extent - (2 @ 0)]".
	m position: self center - (m extent // 2).
	self addMorph: m.
	m lock! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 16:07'!
pareja
^pareja! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 16:07'!
pareja: aHueco 
	pareja := aHueco.
pareja pareja
ifNil:[pareja pareja:self]! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 20:05'!
receptor
	^receptor ! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 19:53'!
receptor:aReceptorHuecos
receptor:=aReceptorHuecos! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 14:26'!
textPosition
	^ textPosition! !

!Hueco methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 14:26'!
textPosition: aPoint 
	textPosition := aPoint! !


!Hueco methodsFor: 'initialization' stamp: 'jlrr 4/28/2005 11:15'!
defaultColor
	self siguienteColor.
	^
		Colors at: UltimoColor! !

!Hueco methodsFor: 'initialization' stamp: 'jlrr 4/28/2005 19:29'!
initialize
	super initialize.
	self borderColor: self color darker.
	self borderWidth: 1.
	self label: 'hueco'! !


!Hueco methodsFor: 'events-processing' stamp: 'jlrr 4/28/2005 16:35'!
delete
|temp|
temp:=pareja.
	pareja ifNotNil:[pareja:=nil.
temp delete.
].
	super delete! !

!Hueco methodsFor: 'events-processing' stamp: 'jlrr 4/28/2005 20:58'!
mouseDown: evt 
	self dragEnabled
		ifTrue: [
huecoConectado ifNotNil:[huecoConectado huecoConectado:nil. huecoConectado:=nil].
self currentHand attachMorph: self]
		ifFalse: [self grabMorph: evt]! !


!Hueco methodsFor: 'private' stamp: 'jlrr 4/28/2005 16:26'!
dropAcceptedMorph: transferMorph from: targetMorph 
	
	targetMorph class= ReceptorHuecos
		ifFalse: [transferMorph passenger delete.
			self delete]! !

!Hueco methodsFor: 'private' stamp: 'jlrr 4/28/2005 16:27'!
dropRejectedMorph: aTransferMorph 
	aTransferMorph passenger delete.
			self delete! !

!Hueco methodsFor: 'private' stamp: 'jlrr 4/28/2005 11:07'!
siguienteColor
	"Use the next color in the standard sequence."
	
	Colors
		ifNil: [self class initialize].
	UltimoColor
		ifNil: [UltimoColor := 1]
		ifNotNil: [UltimoColor := UltimoColor + 1.
			UltimoColor > Colors size
				ifTrue: [UltimoColor := 1
					"ifNotNil: [LastColorIndex \\ Colors size +
					1]"]]! !


!Hueco methodsFor: 'event handling' stamp: 'jlrr 4/28/2005 19:29'!
handlesMouseDown: evt 
	manejable
		ifNil: [manejable := true].
	^manejable
		! !


!Hueco methodsFor: 'comparing' stamp: 'jlrr 4/28/2005 18:27'!
isEqual:aHueco
^( pareja==aHueco)! !


!Hueco methodsFor: 'visual properties' stamp: 'jlrr 5/4/2005 19:57'!
opaco
	| oldLabel |
	self color: self color asNontranslucentColor.
(oldLabel := self findA: StringMorph)
		ifNotNil: [oldLabel color:self color negated].
	! !

!Hueco methodsFor: 'visual properties' stamp: 'jlrr 5/7/2005 16:37'!
removeBold
	| oldLabel |
	(oldLabel := self findA: StringMorph)
		ifNotNil: [oldLabel emphasis: 0.self extent:oldLabel extent]! !

!Hueco methodsFor: 'visual properties' stamp: 'jlrr 4/28/2005 21:02'!
tapado
	"self color: self color asNontranslucentColor."
	| oldLabel |
	self color: Color black.
	oldLabel := self findA: StringMorph.
	oldLabel color: self color.
	manejable := false! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Hueco class
	instanceVariableNames: ''!

!Hueco class methodsFor: 'class initialization' stamp: 'jlrr 4/28/2005 11:03'!
initialize
	UltimoColor := 0.
	
	Colors := {TranslucentColor
				r: 0.0
				g: 0.0
				b: 0.839
				alpha: 0.267. TranslucentColor
				r: 0.484
				g: 1.0
				b: 0.452
				alpha: 0.706. TranslucentColor
				r: 1.0
				g: 0.355
				b: 0.71
				alpha: 0.569. TranslucentColor
				r: 1.0
				g: 1.0
				b: 0.03
				alpha: 0.561. TranslucentColor
				r: 0.484
				g: 0.161
				b: 1.0
				alpha: 0.529. TranslucentColor
				r: 0.097
				g: 0.097
				b: 0.097
				alpha: 0.192}! !


AlignmentMorphBob1 subclass: #PanelEjercicios
	instanceVariableNames: 'titulo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 5/18/2005 20:13'!
createBoton
	| textColor1 |
	textColor1 := Color
				r: 0.742
				g: 0.839
				b: 1.0.
	^ {self
		createBoton: {'Quit' translated. Color red}
		accion: #delete
		textColor: textColor1}! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:21'!
createBotones
	| textColor1 |
	textColor1 := Color
				r: 0.742
				g: 0.839
				b: 1.0.
	^ {(self
		createBoton: {'Quit' translated. Color red}
		accion: #delete
		textColor: textColor1)
		extent: 60 @ 40. (Morph new extent: 30 @ 5)
		color: Color transparent. (self
		createBoton: {'Open' translated. Color green}
		accion: #cargarEjercicio
		textColor: textColor1)
		extent: 60 @ 40. (Morph new extent: 10 @ 5)
		color: Color transparent. (self
		createBoton: {'Save' translated. Color green}
		accion: #guardarEjercicio
		textColor: textColor1)
		extent: 70 @ 40. (Morph new extent: 30 @ 5)
		color: Color transparent. (self
		createBoton: {'Generate Exercise' translated. Color paleBlue}
		accion: #generar
		textColor: Color white)
		extent: 130 @ 40}! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/23/2005 19:14'!
createBoton: aCollection accion: aSymbol textColor: aColor 
	"boton := FileList2 
				blueButtonText: aCollection first
				textColor: aColor
				color: aCollection second
				inWindow: self.
"

	| boton |
	boton := (SimpleButtonMorph newWithLabel: aCollection first)
				extent: 100 @ 40;
				borderColor: Color black;
				color: aCollection second.
	boton 
		on: #mouseUp
		send: aSymbol
		to: self.
	^boton
	"Ejemplo:
createBoton:{ 'Evaluar'. (ColorTheme current okColor) } accion:#delete textColor:Color black
"! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/23/2005 20:08'!
createColumn
	"create a column"

	| column panel |
	panel := (ScrollPane new)
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				hResizing: #spaceFill;
				extent: 200 @ 1;
				vResizing: #spaceFill;
				wrapCentering: #center;
				cellPositioning: #center;
				borderWidth: 0.
	
	column := (self inARow: { (self inAColumn: { panel }) })
				useRoundedCorners;
				layoutInset: 0;
				borderWidth: 1;
				borderColor: (Color r: 1.0 g: 0.8 b: 0.0);
				color:Color lightYellow .
				"fillWithRamp: ColorTheme current dialogPaneRampOrColor oriented: 0.7 @ 0.35."
	^column! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/23/2005 19:57'!
createColumn: aCollection 
	"create a column"

	| column panel |
	panel := (ScrollPane new)
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				hResizing: #spaceFill;
				extent: 200 @ 1;
				vResizing: #spaceFill;
				wrapCentering: #center;
				cellPositioning: #center;
hideScrollBars;
				borderWidth: 0.
	self rellenaPanel: panel con: aCollection.
	column := (self inARow: { (self inAColumn: { panel }) })
				useRoundedCorners;
				layoutInset: 0;
				borderWidth: 1;
				borderColor: (Color r: 1.0 g: 0.8 b: 0.0);
			     color:(Color lightYellow).
				
	 ^column! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/7/2005 19:18'!
createRow
	"create a row"

	| row |
	row := AlignmentMorph newRow.
	row
		layoutInset: 2;
		wrapCentering: #center;
		cellPositioning: #leftCenter.
	""
	^row! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/7/2005 19:18'!
createStatusBar
	"create the statusbar for the receiver"

	| statusbar |
	statusbar := (UpdatingStringMorph on: self selector: #status)
				growable: true;
				useStringFormat;
				stepTime: 1000;
				hResizing: #spaceFill.
	^{
		((AlignmentMorph newRow)
			extent: 100 @ 5;
			addMorph: statusbar)
		"	hResizing: #spaceFill;"
	}! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/23/2005 19:57'!
createWindow
	self listDirection: #topToBottom;
		 extent: 1 @ 1;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 borderWidth: 2;
		
		borderColor: (Color
				r: 0.0
				g: 0.4
				b: 0.8);
		 useRoundedCorners.
self color:(Color r: 0.8 g: 1.0 b: 0.9).
	"self fillWithRamp: (Color r: 0.8 g: 1.0 b: 0.9) oriented: 0.65."
	self addARow: {self
			fancyText: titulo
			font: (Preferences standardEToysFont pointSize: 14)
			color: (Color
					r: 0.742
					g: 0.839
					b: 1.0)}! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 22:00'!
guardarEjercicio:anExtension con:aName
	| nombre directorio nombreFinal |
	nombre := FillInTheBlank request: 'File name:' translated initialAnswer: aName.
	nombre isEmpty
		ifFalse: [nombreFinal := nombre copy.
			(nombre endsWith:anExtension)
				ifFalse: [nombreFinal := nombre , anExtension].
			directorio := FileDialog new dirSelect.
			directorio
				ifNotNil: [self generaDocXML
						printOn: (directorio  newFileNamed: nombreFinal)]]! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/7/2005 19:23'!
paneColor
	^Color blue alpha: 0.1! !

!PanelEjercicios methodsFor: 'user interface' stamp: 'jlrr 4/7/2005 19:20'!
rellenaPanel: anAlignmentMorph con: aCollection 
	"Para que conecten los conectores es necesario colocar un PasteUpMorph"

	aCollection do: 
			[:each | 
			anAlignmentMorph addMorph: ((PasteUpMorph new)
						color: Color transparent;
						hResizing: #shrinkWrap;
						vResizing: #shrinkWrap;
						borderWidth: 0;
						addMorph: each)]! !


!PanelEjercicios methodsFor: 'private' stamp: 'jlrr 4/23/2005 20:20'!
fancyText: aString font: aFont color: aColor 
	| answer tm col |
	col := aColor negated.
	tm := TextMorph new.
	tm beAllFont: aFont;
		 color: col;
		 contents: aString.
	answer := self inAColumn: {tm}.

	tm lock.
	^ answer! !


!PanelEjercicios methodsFor: 'initialization' stamp: 'jlrr 4/7/2005 19:32'!
initialize
super initialize.
	titulo := 'Tipo de Ejercicio'.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PanelEjercicios class
	instanceVariableNames: ''!

!PanelEjercicios class methodsFor: 'instance creation' stamp: 'jlrr 5/17/2005 21:29'!
newStandAlone
|temp|
temp:=super newStandAlone.
temp createWindow.
^temp.! !


PanelEjercicios subclass: #PanelHuecos
	instanceVariableNames: 'huecos texto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!PanelHuecos methodsFor: 'accessing' stamp: 'jlrr 5/7/2005 16:36'!
addHueco: aHueco 
	| pareja |
	aHueco pareja
		ifNil: ["creando ejercicio al leer archivo"
			pareja := aHueco copy.
			aHueco pareja: pareja.
			pareja borderWidth: 0;
				 label: aHueco label ;removeBold]
		ifNotNil: [pareja := aHueco pareja copy.
			pareja enableDrop: true;
				 tapado.
			aHueco enableDrag: true].
	pareja receptor: texto textMorph;
		 pareja: aHueco.
	texto textMorph addMorphFront: pareja.
	texto textMorph selectFrom: pareja comienzo to: pareja fin.
	pareja position: texto textMorph paragraph selectionRects first origin + (4 @ 2).
	pareja textPosition: pareja position.
	aHueco position: huecos position + pareja position;
		 textPosition: pareja position;
		 receptor: huecos.
	huecos addMorph: aHueco! !

!PanelHuecos methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 17:31'!
huecos
	^ huecos huecos! !

!PanelHuecos methodsFor: 'accessing' stamp: 'jlrr 5/5/2005 17:32'!
huecos: aCollection 
	
	aCollection
		collect: [:each | 
			
			self addHueco:each copy]! !

!PanelHuecos methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 17:31'!
texto
	^ texto text! !

!PanelHuecos methodsFor: 'accessing' stamp: 'jlrr 5/4/2005 20:07'!
texto: aText 
	texto setText: aText! !


!PanelHuecos methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:22'!
createWindow
	| separador |
	super createWindow.
	huecos := ReceptorHuecos new extent: 500 @ 100.
	texto := PluggableTextForHuecos new extent: 500 @ 200;
				 color: Color white;
				 setText: 'Write or paste the text here...' translated.
	self addARow: {huecos}.
	separador := self addARow: {(Morph new extent: 30 @ 20)
					color: Color transparent}.
	self addMorph: texto after: separador! !


!PanelHuecos methodsFor: 'initialization' stamp: 'jlrr 5/11/2005 16:22'!
initialize
	super initialize.
	titulo := 'Filling blanks' translated! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PanelHuecos class
	instanceVariableNames: ''!

!PanelHuecos class methodsFor: 'instance creation' stamp: 'jlrr 4/28/2005 17:28'!
abrir
	^ self new createWindow openInWorld! !

!PanelHuecos class methodsFor: 'instance creation' stamp: 'jlrr 5/4/2005 20:09'!
abrir: aText con: aCollection 
	^ self new createWindow; texto: aText;  openInWorld;huecos: aCollection! !


PanelHuecos subclass: #EjercicioHuecos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!EjercicioHuecos methodsFor: 'model access' stamp: 'jlrr 5/18/2005 20:30'!
corregir
	| tmp hechos bien |
	tmp := texto textMorph submorphs
				select: [:each | each class = Hueco].
	hechos := tmp
				select: [:each | each huecoConectado notNil & (each color = Color black)].
	bien := 0.
	hechos
		collect: [:each | (each isEqual: each huecoConectado)
				ifTrue: [bien := bien + 1]].
	hechos size > 0
		ifTrue: [^ '{1} matched words and {2} wrong words' translated format: {bien. hechos size - bien}]
		ifFalse: [^ 'Drag words and drop them in their matching blanks.' translated]! !


!EjercicioHuecos methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:51'!
createWindow
	super createWindow.
	self addARow: self createStatusBar;
		 addARowCentered: self createBoton.
	"para que no genere nuevas parejas si se est· haciendo el
	ejercicio:"
	texto textMorph locked: true! !

!EjercicioHuecos methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:40'!
status
	^self corregir.
! !


!EjercicioHuecos methodsFor: 'initialization' stamp: 'jlrr 4/28/2005 21:01'!
initialize
	super initialize.
	! !


PanelHuecos subclass: #GeneradorHuecos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!GeneradorHuecos methodsFor: 'model' stamp: 'jlrr 5/7/2005 10:37'!
cargarEjercicio
	| file ejercicio documento |
	file := FileDialog new fileSelect: #('*.jcl' '*.scl' ).
	file
		ifNotNil: [documento := ParserEjercicios parseStream: file.
ejercicio:=documento at:1.
	ejercicio openInWorld.
	self delete]! !

!GeneradorHuecos methodsFor: 'model' stamp: 'jlrr 4/28/2005 18:10'!
generar
	EjercicioHuecos abrir: (self texto ) con: (self huecos)! !

!GeneradorHuecos methodsFor: 'model' stamp: 'jlrr 5/11/2005 22:00'!
guardarEjercicio
self guardarEjercicio:'scl' con:'huecos.scl'
	! !


!GeneradorHuecos methodsFor: 'user interface' stamp: 'jlrr 4/28/2005 17:30'!
createWindow
	| |
	super createWindow.

	self addARowCentered: self createBotones! !


!GeneradorHuecos methodsFor: 'private' stamp: 'jlrr 5/7/2005 12:02'!
generaDocXML
	| doc ejer gap answers inicio answer |
	doc := XMLDocument new.
	ejer := XMLElement named: #'holes-exercice' attributes: Dictionary new.
	gap := XMLElement named: #'gap-fill' attributes: Dictionary new.
	answers := SortedCollection
				sortBlock: [:a :b | a comienzo < b comienzo].
	answers addAll: self huecos.
	inicio := 1.
	answers
		collect: [:each | 
			gap
				addElement: (XMLStringNode
						string: (texto text copyFrom: inicio to: each comienzo - 1)).
			inicio := each fin.
			answer := XMLElement named: #'question-record' attributes: Dictionary new.
			answer
				addElement: ((XMLElement named: #text attributes: Dictionary new)
						addElement: (XMLStringNode string: each label)).
			gap addElement: answer].
	gap
		addElement: (XMLStringNode
				string: (texto text copyFrom: inicio to: texto text size)).
	ejer addElement: gap.
	doc addElement: ejer.
	doc version: '1.0'.
	
	^ doc! !


PanelEjercicios subclass: #PanelParejas
	instanceVariableNames: 'parejas panelIzquierdo panelDerecho'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!PanelParejas methodsFor: 'panes' stamp: 'jlrr 5/10/2005 18:58'!
addMorph: aMorph frame: relFrame 
	| frame |
	frame := LayoutFrame new.
	frame
		leftFraction: relFrame left;
		rightFraction: relFrame right;
		topFraction: relFrame top;
		bottomFraction: relFrame bottom.
	self addMorph: aMorph fullFrame: frame! !


!PanelParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 13:28'!
createWindow
	
	super createWindow.
	panelIzquierdo := self createColumn: self listaIzquierda.
	panelDerecho := self createColumn: self listaDerecha.
	self addARow: {(self inAColumn: {panelIzquierdo})
			layoutInset: 10. (self inAColumn: {panelDerecho})
			layoutInset: 10};
		
		adoptPaneColor: (Color
				r: 0.548
				g: 0.677
				b: 1.0);
		 fullBounds! !

!PanelParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 10:19'!
listaDerecha
	^ parejas
				select: [:each | each lado = 'derecho'].
	! !

!PanelParejas methodsFor: 'user interface' stamp: 'jlrr 5/10/2005 18:58'!
listaIzquierda
^ parejas select: [:each | each lado = 'izquierdo'].

	! !


!PanelParejas methodsFor: 'initialization' stamp: 'jlrr 5/11/2005 16:23'!
initialize
	super initialize.
	parejas
		ifNil: [parejas := OrderedCollection new].
	titulo := 'Matching pairs' translated! !


!PanelParejas methodsFor: 'accessing' stamp: 'jlrr 5/10/2005 18:58'!
parejas:anOrderedCollection
	parejas:=anOrderedCollection! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PanelParejas class
	instanceVariableNames: ''!

!PanelParejas class methodsFor: 'class initialization' stamp: 'jlrr 5/10/2005 18:58'!
abrir
| ejercicio |
ejercicio:=(self new)
		createWindow;
		openInWorld.
^ejercicio! !

!PanelParejas class methodsFor: 'class initialization' stamp: 'jlrr 5/10/2005 18:58'!
abrir: anOrderedCollection 
	| ejercicio |
	ejercicio := (self new)
				parejas: anOrderedCollection;
				createWindow;
				openInWorld.
	^ejercicio! !

!PanelParejas class methodsFor: 'class initialization' stamp: 'jlrr 5/10/2005 18:58'!
ejemplo
	| listado listaDerecha |
	listado := OrderedCollection new.
	listado add: (ElementoParejas izquierdo: 'Alan' derecho: 'Kay').
	listado add: (ElementoParejas izquierdo: 'Dan' derecho: 'Ingalls').
	listado add: (ElementoParejas izquierdo: 'John' derecho: 'Maloney').
	listado add: (ElementoParejas izquierdo: 'Scott' derecho: 'Wallace').
	listado add: (ElementoParejas izquierdo: 'Doug' derecho: 'Engelbart').
	listado add: (ElementoParejas izquierdo: 'Seimour' derecho: 'Papert').
	listaDerecha := listado copy.
	listaDerecha do: [:each | listado add: each pareja].
	self abrir: listado! !


PanelParejas subclass: #EjercicioParejas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!EjercicioParejas methodsFor: 'accessing' stamp: 'jlrr 3/22/2005 16:46'!
coleccionDesordenada: aCollection
	| copy aRandom |
	aRandom := Random new.
	copy := aCollection asSet.
	copy size to: 1
		by: -1
		do: [:i | copy swap: i with: ((1 to: i) atRandom: aRandom)].
	^copy! !


!EjercicioParejas methodsFor: 'model access' stamp: 'jlrr 5/11/2005 16:46'!
corregir
	| aciertos fallos lista |
	lista := self listaIzquierda.
	aciertos := 0.
	fallos := 0.
	lista
		do: [:each | each elementoConectado
				ifNotNil: [each pareja = each elementoConectado
						ifTrue: [aciertos := aciertos + 1]
						ifFalse: [fallos := fallos + 1]]].
	
^ 'Total pairs: {1}, with {2} successes and {3} mistakes. ' translated format: {lista size. aciertos. fallos}! !


!EjercicioParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:50'!
createWindow
	super createWindow.
	self addARow: self createStatusBar;
		 addARowCentered: self createBoton.
	self position: World topLeft + (World extent - self extent // 2)! !

!EjercicioParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 10:20'!
listaDerecha

	^ self coleccionDesordenada: super listaDerecha
! !

!EjercicioParejas methodsFor: 'user interface' stamp: 'jlrr 3/23/2005 16:58'!
listaIzquierda
^ parejas select: [:each | each lado = 'izquierdo'].

	! !

!EjercicioParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:41'!
status
	^self corregir.
	! !


!EjercicioParejas methodsFor: 'initialization' stamp: 'jlrr 5/11/2005 16:47'!
initialize
	super initialize.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

EjercicioParejas class
	instanceVariableNames: ''!

!EjercicioParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/22/2005 16:50'!
abrir
| ejercicio |
ejercicio:=(self new)
		createWindow;
		openInWorld.
^ejercicio! !

!EjercicioParejas class methodsFor: 'class initialization' stamp: 'jlrr 4/1/2005 19:15'!
abrir: anOrderedCollection 
	| ejercicio |
	ejercicio := (self new)
				parejas: anOrderedCollection;
				createWindow;
				openInWorld.
	^ejercicio! !

!EjercicioParejas class methodsFor: 'class initialization' stamp: 'jlrr 3/22/2005 21:15'!
ejemplo
	| listado listaDerecha |
	listado := OrderedCollection new.
	listado add: (ElementoParejas izquierdo: 'Alan' derecho: 'Kay').
	listado add: (ElementoParejas izquierdo: 'Dan' derecho: 'Ingalls').
	listado add: (ElementoParejas izquierdo: 'John' derecho: 'Maloney').
	listado add: (ElementoParejas izquierdo: 'Scott' derecho: 'Wallace').
	listado add: (ElementoParejas izquierdo: 'Doug' derecho: 'Engelbart').
	listado add: (ElementoParejas izquierdo: 'Seimour' derecho: 'Papert').
	listaDerecha := listado copy.
	listaDerecha do: [:each | listado add: each pareja].
	self abrir: listado! !


PanelParejas subclass: #GeneradorParejas
	instanceVariableNames: 'izquierda derecha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!GeneradorParejas methodsFor: 'model' stamp: 'jlrr 5/11/2005 14:20'!
cargarEjercicio
	| file |
	file := FileDialog new fileSelect: #('*.jmt' '*.smt' ).
	file
		ifNotNil: [parejas := ParserEjercicios parseStream: file.
			self
				llenaPanel: izquierda
				con: (parejas
						select: [:each | each lado = 'izquierdo']).
			self
				llenaPanel: derecha
				con: (parejas
						select: [:each | each lado = 'derecho'])]! !

!GeneradorParejas methodsFor: 'model' stamp: 'jlrr 5/11/2005 14:20'!
cargarEjercicio: aCollection 
	parejas := aCollection.
	self
		llenaPanel: izquierda
		con: (parejas
				select: [:each | each lado = 'izquierdo']).
	self
		llenaPanel: derecha
		con: (parejas
				select: [:each | each lado = 'derecho'])! !

!GeneradorParejas methodsFor: 'model' stamp: 'jlrr 5/11/2005 14:17'!
generar
	| lista elementoIzquierdo elementoDerecho |

	lista := OrderedCollection new.
	1
		to: 12
		do: [:a | 
			elementoIzquierdo := (izquierda at: a) contents.
			elementoDerecho := (derecha at: a) contents.
			elementoIzquierdo isEmpty not & elementoDerecho isEmpty not
				ifTrue: [lista
						add: (ElementoParejas izquierdo: elementoIzquierdo derecho: elementoDerecho)]].
	parejas := lista copy.
	lista
		do: [:each | parejas add: each pareja].
	EjercicioParejas abrir: parejas! !

!GeneradorParejas methodsFor: 'model' stamp: 'jlrr 5/11/2005 22:01'!
guardarEjercicio
self guardarEjercicio:'smt' con:'parejas.smt'
! !


!GeneradorParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 14:18'!
createWindow
	super createWindow.
	self addARowCentered: super createBotones.
	izquierda := panelIzquierdo allMorphs
				select: [:each | each class = NCTextMorph].
	derecha := panelDerecho allMorphs
				select: [:each | each class = NCTextMorph].! !

!GeneradorParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 13:24'!
listaDerecha
	^self listaIzquierda! !

!GeneradorParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 13:36'!
listaIzquierda
	| lista aMorph |
	lista := OrderedCollection new.
	12
		timesRepeat: [aMorph := NCTextMorph new contents: ''.
			aMorph borderWidth: 1;
				 acceptOnCR: true;
				 wrapFlag: true;
extent:300@20;
				 backgroundColor: Color white.
			lista add: aMorph].
	^ lista! !

!GeneradorParejas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 13:39'!
rellenaPanel: anAlignmentMorph con: aCollection 
	"Para que conecten los conectores es necesario colocar un
	PasteUpMorph"
	aCollection
		do: [:each | anAlignmentMorph addMorph: each;
				
				addMorph: ((Morph new extent: 5 @ 5)
						color: Color transparent)]! !


!GeneradorParejas methodsFor: 'private' stamp: 'jlrr 5/11/2005 14:21'!
generaDocXML
	| doc ejer elementoIzquierdo elementoDerecho |
	doc := XMLDocument new.
	ejer := XMLElement named: #'matching-exercice' attributes: Dictionary new.

	1
		to: 12
		do: [:a | 
			elementoIzquierdo := (izquierda at: a) contents.
			elementoDerecho := (derecha at: a) contents.
			"Para guardar el ejercico puede haber parejas
			incompletas: "
			elementoIzquierdo isEmpty not | elementoDerecho isEmpty not
				ifTrue: [ejer
						addElement: (self parejaXML: elementoIzquierdo con: elementoDerecho)]].
	doc addElement: ejer.
	doc version: '1.0'.
	^ doc! !

!GeneradorParejas methodsFor: 'private' stamp: 'jlrr 5/11/2005 14:20'!
llenaPanel: aTextCollection con: aCollection 
	"textos := anAlignmentMorph submorphs
	collect: [:each | each contents: '']."
	| coleccion |

	aCollection size > aTextCollection size
		ifTrue: [coleccion := aCollection copyFrom: 1 to: aTextCollection size]
		ifFalse: [coleccion := aCollection copy].
	coleccion
		withIndexCollect: [:each :index | each texto
				ifNotNil: [(aTextCollection at: index) contents: each texto;
						 wrapFlag: true;
						 extent: 300 @ 20]]! !

!GeneradorParejas methodsFor: 'private' stamp: 'jlrr 5/11/2005 10:46'!
parejaXML: aString con: anotherString 
	| par izquierdo derecho textoIzquierdo textoDerecho |
	par := XMLElement named: #pair attributes: Dictionary new.
	izquierdo := XMLElement named: #'left-item' attributes: Dictionary new.
	textoIzquierdo := (XMLElement named: #text attributes: Dictionary new)
	 addElement: (XMLStringNode string: aString).
	izquierdo addElement: textoIzquierdo.
	derecho := XMLElement named: #'right-item' attributes: Dictionary new.
	textoDerecho := (XMLElement named: #text attributes: Dictionary new) 
				addElement: (XMLStringNode string: anotherString).
	derecho addElement: textoDerecho.
	par addElement: izquierdo.
	par addElement: derecho.
	^par! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GeneradorParejas class
	instanceVariableNames: ''!

!GeneradorParejas class methodsFor: 'class initialization' stamp: 'jlrr 5/11/2005 10:46'!
abrir
	^self new createWindow openInWorld! !

!GeneradorParejas class methodsFor: 'class initialization' stamp: 'jlrr 5/11/2005 10:46'!
abrir:aPasteUpMorph
self new createWindow openInWorld:aPasteUpMorph! !

!GeneradorParejas class methodsFor: 'class initialization' stamp: 'jlrr 5/11/2005 10:46'!
ejemplo
	| listado listaDerecha |
	listado := OrderedCollection new.
	listado add: (ElementoParejas izquierdo: 'Alan' derecho: 'Kay').
	listado add: (ElementoParejas izquierdo: 'Dan' derecho: 'Ingalls').
	listado add: (ElementoParejas izquierdo: 'John' derecho: 'Maloney').
	listado add: (ElementoParejas izquierdo: 'Scott' derecho: 'Wallace').
	listado add: (ElementoParejas izquierdo: 'Doug' derecho: 'Engelbart').
	listado add: (ElementoParejas izquierdo: 'Seimour' derecho: 'Papert').
	listaDerecha := listado copy.
	listaDerecha do: [:each | listado add: each pareja].
	(self abrir)

		cargarEjercicio: listado! !


PanelEjercicios subclass: #PanelPreguntas
	instanceVariableNames: 'preguntas siguiente textoPregunta textosRespuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!PanelPreguntas methodsFor: 'model' stamp: 'jlrr 4/7/2005 20:18'!
anterior
	siguiente < 2 
		ifTrue: [siguiente := preguntas size]
		ifFalse: [siguiente := siguiente - 1].
	self escribePregunta: (preguntas at: siguiente)! !

!PanelPreguntas methodsFor: 'model' stamp: 'jlrr 4/9/2005 18:08'!
siguiente
	siguiente >= preguntas size 
		ifTrue: [siguiente := 1]
		ifFalse: [siguiente := siguiente + 1].
	self escribePregunta: (preguntas at: siguiente)! !


!PanelPreguntas methodsFor: 'user interface' stamp: 'jlrr 4/9/2005 12:50'!
createWindow
	super createWindow.
	
	textosRespuestas := self createColumn.
	! !

!PanelPreguntas methodsFor: 'user interface' stamp: 'jlrr 4/9/2005 18:13'!
escribePregunta: aPregunta 

	textosRespuestas submorphs do: [:each | each delete]! !


!PanelPreguntas methodsFor: 'accessing' stamp: 'jlrr 4/7/2005 21:12'!
preguntas: anOrderedCollection 
	preguntas := anOrderedCollection.
siguiente:=1! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PanelPreguntas class
	instanceVariableNames: ''!

!PanelPreguntas class methodsFor: 'class initialization' stamp: 'jlrr 4/7/2005 21:11'!
abrir: anOrderedCollection 
	| ejercicio |
	ejercicio := (self new)
				preguntas: anOrderedCollection;
				createWindow;
				openInWorld.
	^ejercicio! !

!PanelPreguntas class methodsFor: 'class initialization' stamp: 'jlrr 5/13/2005 18:26'!
ejemplo
	| listado pregunta1 pregunta2 pregunta3 pregunta4 |
	listado := OrderedCollection new.
	pregunta1 := Pregunta 
				enunciado: '¿De qué color es el caballo blanco de Santiago?'.
	pregunta1 addRespuesta: (Respuesta enunciado: 'Marrón' es: false).
	pregunta1 addRespuesta: (Respuesta enunciado: 'Blanco' es: true).
	pregunta1 addRespuesta: (Respuesta enunciado: '¿y porqué el cielo es azul, a qué huelen las nubes, vaya pregunta más tonta' es: false).
	""
	pregunta2 := Pregunta 
				enunciado: '¿Cuántos tipos de personas hay en el mundo?'.
	pregunta2 addRespuesta: (Respuesta 
				enunciado: '10, los que saben binario y los que no'
				es: true).
	pregunta2 addRespuesta: (Respuesta enunciado: 'Sabrá Dios' es: true).
	pregunta2 
		addRespuesta: (Respuesta enunciado: 'Los que el profesor diga' es: false).
	""
	pregunta3 := Pregunta enunciado: '¿Cuál es el mayor enemigo de LinEx?'.
	pregunta3 addRespuesta: (Respuesta enunciado: 'SuperMegaSoft' es: false).
	pregunta3 addRespuesta: (Respuesta enunciado: 'Guillermo Puertas' es: false).
	pregunta3 addRespuesta: (Respuesta enunciado: 'Guadalinex' es: false).
	pregunta3 addRespuesta: (Respuesta enunciado: 'El perillas' es: true).
	""
	pregunta4 := Pregunta enunciado: '¿Soy tan guapo como creo?'.
	pregunta4 addRespuesta: (Respuesta enunciado: 'Verdadero' es: true).
	pregunta4 addRespuesta: (Respuesta enunciado: 'Falso' es: false).
	""
	listado add: pregunta1.
	listado add: pregunta2.
	listado add: pregunta3.
	listado add: pregunta4.
	self abrir: listado! !


PanelPreguntas subclass: #EjercicioPreguntas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!EjercicioPreguntas methodsFor: 'model' stamp: 'jlrr 5/11/2005 16:43'!
corregir
	| aciertos errores |
	aciertos := 0.
	errores := 0.
	preguntas
		do: [:pregunta | pregunta respuestas
				do: [:respuesta | respuesta marcada
						ifTrue: [respuesta verdadera
								ifTrue: [aciertos := aciertos + 1]
								ifFalse: [errores := errores + 1]]]].
^'Total questions: {1}, with {2} successes and {3} mistakes. ' translated format: {preguntas size. aciertos. errores}! !

!EjercicioPreguntas methodsFor: 'model' stamp: 'jlrr 5/11/2005 16:36'!
status
	^self corregir.
	! !


!EjercicioPreguntas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 16:51'!
createBotones

	^ super createBoton,{(Morph new extent: 80 @ 5)
		color: Color transparent. self
		createBoton: {'Next' translated. Color yellow}
		accion: #anterior
		textColor: Color yellow. (Morph new extent: 10 @ 5)
		color: Color transparent. self
		createBoton: {'Previous' translated. Color yellow}
		accion: #siguiente
		textColor: Color yellow}! !

!EjercicioPreguntas methodsFor: 'user interface' stamp: 'jlrr 4/9/2005 12:50'!
createWindow
	super createWindow.

	textoPregunta := (TextMorph new)
				width: 400;
				borderWidth: 0;
				backgroundColor: Color transparent;
				margins: 20;
				autoFit: true;
				wrapFlag: true.
	
	self
		addARow: { textoPregunta };
		addARow: { textosRespuestas }.


	self
		addARow: self createStatusBar;
		addARowCentered: self createBotones.
	self escribePregunta: preguntas first! !

!EjercicioPreguntas methodsFor: 'user interface' stamp: 'jlrr 4/10/2005 21:11'!
escribePregunta: aPregunta 
	| bloque bloqueRespuestas |
	super escribePregunta: aPregunta.
	textoPregunta newContents: aPregunta enunciado.

bloqueRespuestas := (aPregunta respuestas 
				select: [:each | each enunciado isNil not]) 

				collect: [:each | each pintaPreguntaAncho: 500 @ 1].
	bloque := self createColumn: bloqueRespuestas.
	textosRespuestas 
		addMorphBack: ((self inAColumn: { bloque }) layoutInset: 10)! !


!EjercicioPreguntas methodsFor: 'initialization' stamp: 'jlrr 5/18/2005 20:11'!
initialize
	super initialize.
	titulo := 'Choose the right answers in the questions' translated.! !


PanelPreguntas subclass: #GeneradorPreguntas
	instanceVariableNames: 'preguntaActiva'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!GeneradorPreguntas methodsFor: 'model' stamp: 'jlrr 4/25/2005 01:51'!
borrar
	preguntas remove: preguntaActiva.
	preguntas size = 0
		ifTrue: [preguntas add: self preguntaEjemplo].
self siguiente.! !

!GeneradorPreguntas methodsFor: 'model' stamp: 'jlrr 4/9/2005 21:24'!
cargarEjercicio
	| file |
	file := FileDialog new fileSelect: #('*.jqz' '*.sqz' ).
	file ifNotNil: [preguntas := ParserEjercicios parseStream: file].
	
	self escribePregunta: preguntas first.! !

!GeneradorPreguntas methodsFor: 'model' stamp: 'jlrr 4/25/2005 02:25'!
create
| question |
question:=self preguntaEjemplo.
	preguntas add: question.
self
		escribePregunta:question.! !

!GeneradorPreguntas methodsFor: 'model' stamp: 'jlrr 4/9/2005 19:41'!
generar
EjercicioPreguntas abrir:preguntas.
	! !

!GeneradorPreguntas methodsFor: 'model' stamp: 'jlrr 5/11/2005 22:01'!
guardarEjercicio
self guardarEjercicio:'sqz' con:'preguntas.sqz'
! !


!GeneradorPreguntas methodsFor: 'user interface' stamp: 'jlrr 5/11/2005 10:54'!
createBotones

	^ super createBotones , {(Morph new extent: 30 @ 5)
			color: Color transparent. (self
			createBoton: {'<--'. Color yellow}
			accion: #anterior
			textColor: Color yellow)
			extent: 40 @ 40. (Morph new extent: 10 @ 5)
			color: Color transparent. (self
			createBoton: {'-->'. Color yellow}
			accion: #siguiente
			textColor: Color yellow)
			extent: 40 @ 40}! !

!GeneradorPreguntas methodsFor: 'user interface' stamp: 'jlrr 5/18/2005 20:06'!
createWindow
	| textColor1 nuevo borrar |
	super createWindow.
	textColor1 := Color
				r: 0.742
				g: 0.839
				b: 1.0.
	textoPregunta := PluggableTextMorph
				on: self
				text: #enunciadoPregunta
				accept: #enunciadoPregunta:
				readSelection: nil
				menu: nil.
	borrar := (self
				createBoton: {'Remove' translated. Color red}
				accion: #borrar
				textColor: textColor1)
				extent: 60 @ 30.
	nuevo := (self
				createBoton: {'Create' translated. Color green}
				accion: #create
				textColor: textColor1)
				extent: 40 @ 30.
	textoPregunta borderWidth: 1;
		 color: Color white;
		 acceptOnCR: true;
		 vShowScrollBar;
		 askBeforeDiscardingEdits: true;
		 hideHScrollBarIndefinitely: true;
		 extent: 400 @ 80.
	self addARow: {textoPregunta. (Morph new extent: 30 @ 5)
			color: Color transparent. nuevo. (Morph new extent: 10 @ 5)
			color: Color transparent. borrar};
		 addARow: {textosRespuestas}.
	self addARowCentered: self createBotones;
		 escribePregunta: preguntas first! !

!GeneradorPreguntas methodsFor: 'user interface' stamp: 'jlrr 4/10/2005 21:10'!
escribePregunta: aPregunta 
	| bloque bloqueRespuestas |
	super escribePregunta: aPregunta.
	preguntaActiva := aPregunta.
	textoPregunta setText: textoPregunta getText.
	bloqueRespuestas :=( aPregunta respuestas select:[:each |each enunciado isNil not] )collect: 
					[:each | 
					each editaPreguntaAncho: 500 @ 50].
	bloque := self createColumn: bloqueRespuestas.
	textosRespuestas 
		addMorphBack: ((self inAColumn: { bloque }) layoutInset: 10)! !


!GeneradorPreguntas methodsFor: 'accessing' stamp: 'jlrr 5/11/2005 16:25'!
enunciadoPregunta
	preguntaActiva
		ifNil: [^ 'Question statement' translated]
		ifNotNil: [^ preguntaActiva enunciado]! !

!GeneradorPreguntas methodsFor: 'accessing' stamp: 'jlrr 4/9/2005 18:14'!
enunciadoPregunta: aStringOrText 
	preguntaActiva enunciado: aStringOrText! !

!GeneradorPreguntas methodsFor: 'accessing' stamp: 'jlrr 4/9/2005 19:04'!
preguntas: anOrderedCollection
super preguntas:anOrderedCollection.
preguntaActiva:=preguntas first.! !


!GeneradorPreguntas methodsFor: 'private' stamp: 'jlrr 4/25/2005 02:17'!
generaDocXML
	| doc ejer |
	doc := XMLDocument new.
	ejer := XMLElement named: #'questions-exercice' attributes: Dictionary new.
	preguntas
		collect: [:each | ejer
				addElement: (self preguntaXML: each)].

	doc addElement: ejer.
	doc version: '1.0'.
	^ doc! !

!GeneradorPreguntas methodsFor: 'private' stamp: 'jlrr 5/11/2005 16:27'!
preguntaEjemplo
	| pregunta respuesta |
	pregunta := Pregunta new texto: 'Question statement' translated.
	4
		timesRepeat: [(respuesta := Respuesta new) texto: 'answer' translated.
			pregunta addRespuesta: respuesta].
	^ pregunta! !

!GeneradorPreguntas methodsFor: 'private' stamp: 'jlrr 4/25/2005 02:23'!
preguntaXML: aPregunta 
	| pregunta respuestas respuesta textoRespuesta cierta verdadera textoQuestion |
	pregunta := XMLElement named: #'question-record' attributes: Dictionary new.
	textoQuestion := (XMLElement named: #question attributes: Dictionary new)
				addElement: (XMLStringNode string: aPregunta enunciado).
	pregunta addElement: textoQuestion.
	respuestas := XMLElement named: #answers attributes: Dictionary new.
	aPregunta respuestas
		collect: [:each | 
			respuesta := XMLElement named: #answer attributes: Dictionary new.
			textoRespuesta := (XMLElement named: #text attributes: Dictionary new)
						addElement: (XMLStringNode string: each enunciado).
			each verdadera
				ifTrue: [cierta := '1']
				ifFalse: [cierta := '0'].
			verdadera := (XMLElement named: #correct attributes: Dictionary new)
						addElement: (XMLStringNode string: cierta).
			respuesta addElement: textoRespuesta.
			respuesta addElement: verdadera.
			respuestas addElement: respuesta].
	pregunta addElement: respuestas.
	^ pregunta! !


!GeneradorPreguntas methodsFor: 'initialization' stamp: 'jlrr 5/11/2005 16:26'!
initialize
	| coleccion |
	super initialize.
	preguntas
		ifNil: [coleccion := OrderedCollection new.
			coleccion add: self preguntaEjemplo.
			self preguntas: coleccion].
	titulo := 'Options exercise generator' translated! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GeneradorPreguntas class
	instanceVariableNames: ''!

!GeneradorPreguntas class methodsFor: 'class initialization' stamp: 'jlrr 4/24/2005 21:27'!
abrir
	| ejercicio |
	ejercicio := (self new)
				
				createWindow;
				openInWorld.
	^ejercicio! !


PackageInfo subclass: #PaqueteClassroom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!PaqueteClassroom methodsFor: 'instropection' stamp: 'jlrr 5/17/2005 16:50'!
additionalChangeSets
	^#()! !

!PaqueteClassroom methodsFor: 'instropection' stamp: 'jlrr 5/17/2005 16:53'!
changesText
	^ '
"Change Set:		Classroom-jlrr
Date:				12 May 2005
Author:				José L. Redrejo Rodríguez <jredrejo@merida.uned.es>
License:				Squeak''s or MIT

5/17/05:
Build Classroom flap.
The teacher always shows his ip, never his network name

5/12/05:
Initial Release
"'
! !

!PaqueteClassroom methodsFor: 'instropection' stamp: 'jlrr 5/17/2005 16:53'!
cvsID
	^('$Revision: 0.11 $' findTokens: ' $:') second! !


!PaqueteClassroom methodsFor: 'naming' stamp: 'jlrr 5/17/2005 16:49'!
externalName
	^'Classroom'! !

!PaqueteClassroom methodsFor: 'naming' stamp: 'jlrr 5/17/2005 16:49'!
fullName
	^self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PaqueteClassroom class
	instanceVariableNames: ''!

!PaqueteClassroom class methodsFor: 'flaps' stamp: 'jlrr 5/18/2005 19:09'!
createClassroomFlap
	| flap |
	Utilities
		informUser: 'Making new flaps (delete them if you want)...' translated
		during: [(Flaps globalFlapTab: 'Classroom' translated)
				ifNil: [flap := self newClassroomFlap openInWorld; setToPopOutOnDragOver: false.
					Flaps addGlobalFlap: flap].
			Flaps positionNavigatorAndOtherFlapsAccordingToPreference]! !

!PaqueteClassroom class methodsFor: 'flaps' stamp: 'jlrr 5/18/2005 21:22'!
defineFlapClassroom
	"Answer a structure defining the items on the default Classroom flap"
	"PaqueteClassroom newClassroomFlap openInWorld;
	setToPopOutOnDragOver: false."
	^ Array
		with: (Array
				with: #GeneradorParejas
				with: #newStandAlone
				with: 'Matching pairs' translated
				with: 'A matching pairs exercise generator' translated)
		with: (Array
				with: #GeneradorHuecos
				with: #newStandAlone
				with: 'Filling blanks' translated
				with: 'A filling blanks exercise generator' translated)
		with: (Array
				with: #GeneradorPreguntas
				with: #newStandAlone
				with: 'Quiz' translated
				with: 'A quiz exercise generator' translated)
		with: (Array with:#Profesor with:#newStandAlone with:('Teacher' translated) with:( 'Press here if you are a teacher' translated) )
		with: (Array with:#Alumno with:#newStandAlone with:('Student' translated) with:('Press here if you are a student'translated) )! !

!PaqueteClassroom class methodsFor: 'flaps' stamp: 'jlrr 5/18/2005 18:32'!
newClassroomFlap

	"PaqueteClassroom newClassroomFlap openInWorld;
	setToPopOutOnDragOver: false."
	| aFlapTab aStrip student teacher |
	aStrip := self preferredConnectorsFlapBinClass
				newPartsBinWithOrientation: #topToBottom
				andColor: (Color blue muchLighter alpha: 0.8)
				from: self defineFlapClassroom
				buttonClass: self preferredConnectorsButtonClass.
	aFlapTab := FlapTab new referent: aStrip beSticky.
	aFlapTab
		setName: 'Classroom' translated
		edge: #right
		color: Color blue muchLighter.
	aFlapTab setBalloonText: aFlapTab balloonTextForFlapsMenu.
	aStrip beFlap: true.
	aStrip extent: 150 @ self currentWorld height.
	student := aStrip submorphs fifth.
	student actionSelector: #registerInTeacher:;
		 arguments: {'null'}.
	teacher := aStrip submorphs fourth.
	teacher actionSelector: #rebuild:;
		 arguments: {'null'}.
	aStrip
		color: (Color blue muchLighter alpha: 0.8).
	aStrip
		submorphsDo: [:ea | ea updateImage].
	^ aFlapTab! !

!PaqueteClassroom class methodsFor: 'flaps' stamp: 'jlrr 5/18/2005 18:18'!
preferredConnectorsButtonClass
	^ Smalltalk
		at: #NCMakerButton
		ifAbsent: [IconicButton]! !

!PaqueteClassroom class methodsFor: 'flaps' stamp: 'jlrr 5/17/2005 20:17'!
preferredConnectorsFlapBinClass
	^ Smalltalk
		at: #NCPartsBin
		ifAbsent: [PartsBin]! !


!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 18:51'!
changeSetBaseFileNames
	"ConnectorsBasicDistroInfo changeSetBaseFileNames"
	^ self changeSetFullFileNames
		collect: [:ea | FileDirectory localNameFor: ea]! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 18:43'!
changeSetDirectory
	^ FileDirectory default directoryNamed: self changeSetDirectoryName! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 18:45'!
changeSetDirectoryName
	^ 'changeSets'! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 19:38'!
changeSetFullFileNames
	| dir |
	dir := self changeSetDirectory.
	^ self changeSets
		collect: [:s | 
			
			dir
				fullNameFor: (dir lastNameFor: s extension: 'st')]! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 19:35'!
changeSets
	^ {'Classroom'}! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 19:34'!
makeSAR
	"
	PaqueteClassroom makeSAR
	"
	| sar result sarName |
	sar := ZipArchive new.
	self changeSetFullFileNames
		do: [:fileName | sar
				addFile: fileName
				as: (FileDirectory localNameFor: fileName)].
	"self mczFullFileNames
		do: [:fileName | sar
				addFile: fileName
				as: (FileDirectory localNameFor: fileName)]."
	sar addString: self preambleText as: 'install/preamble'.
	sar addString: self postscriptText as: 'install/postscript'.
	result := StandardFileMenu newFile.
	result
		ifNil: [^ nil].
	sarName := result directory fullNameFor: result name.
	sar writeToFileNamed: sarName! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 18:54'!
postscriptText
	^ 'Receptor registerType: ''typeAddress''.
			EToyIncomingMessage registerType: ''typeAddress''.
			EToyGateKeeperEntry allInstances
				collect: [:each | each initialize].
			Receptor initializeMessageHandlers.
			PaqueteClassroom createClassroomFlap.
	
	'! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 19:39'!
preambleText
	^ String
		streamContents: [:stream | 
			self changeSetBaseFileNames
				do: [:csName | stream nextPutAll: 'self fileInMemberNamed: ';
						 print: csName;
						 nextPut: $.;
						 cr].
			"self mczBaseFileNames
				do: [:pkgName | stream nextPutAll: 'self fileInMonticelloZipVersionNamed: ';
						 print: pkgName;
						 nextPut: $.;
						 cr]"]! !

!PaqueteClassroom class methodsFor: 'distribution' stamp: 'jlrr 5/18/2005 18:46'!
projectDirectory
	^ FileDirectory default containingDirectory directoryNamed: 'projects'! !


SAXHandler subclass: #ParserEjercicios
	instanceVariableNames: 'stack tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 3/30/2005 20:59'!
addElemento: aString 
	| elemento |
	elemento := ElementoParejas new.
	elemento lado: aString.
	self document add: elemento.
	(self top at:1  )
		ifNil: [self top at: 1 put: elemento]
		ifNotNil: [(self top at: 1) pareja: elemento].
	^elemento! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/7/2005 16:34'!
characters: aString 
	| temp |
	(self top isKindOf: String)
		ifTrue: [self pop.
			self top texto: aString.
			self push: aString].
	(self top isKindOf: Boolean)
		ifTrue: [self pop.
			self top verdadera: aString = '1'.
			self push: aString = '1'].
	(self top isKindOf: GeneradorHuecos)
		ifTrue: [self top texto: self top texto , aString].
	(self top isKindOf: Hueco)
		ifTrue: [self top label = 'hueco'
				ifTrue: [self top label: aString.
					
					temp := self top receptor texto.
					temp last = Character cr
						ifTrue: [temp := temp copyFrom: 1 to: temp size - 1. self top comienzo:(self top comienzo -1)].
self top fin: self top comienzo + aString size.
					self top receptor texto: temp , aString.
					self top receptor addHueco: self top]]! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/4/2005 20:33'!
pop
	
	"pop the last object in the receiver's stack"
	^ self stack removeLast! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 3/29/2005 21:27'!
push: anObject 
	"push anObject on the receiver's stack"

	self stack add: anObject! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 4/10/2005 20:25'!
startDerecho: attributeList 
	
	^self addElemento: 'derecho'! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/4/2005 21:33'!
startEjercicioHuecos: attributeList 
	| ejercicio |
	ejercicio := GeneradorHuecos new createWindow.
	ejercicio texto: ''.
	tipo := 'Huecos'.
self document add:ejercicio.
	^ ejercicio! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/4/2005 21:28'!
startEjercicio: attributeList 
^ OrderedCollection new! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 4/10/2005 20:54'!
startIzquierdo: attributeList 
	
	^self addElemento: 'izquierdo'! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 4/10/2005 20:50'!
startPareja: attributeList 
	| iniciopareja |
	iniciopareja := Array new: 2.
	
	^iniciopareja! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/6/2005 19:56'!
startPregunta: attributeList 
	| pregunta |
	self top class = GeneradorHuecos
		ifTrue: [pregunta := Hueco new.
			pregunta comienzo: self top texto size.
			pregunta receptor: self top]
		ifFalse: [pregunta := Pregunta new.
			self document add: pregunta].
	^ pregunta! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 4/10/2005 20:01'!
startRespuestas: attributeList 
	| respuestas |
	respuestas := OrderedCollection new.
	
	self top respuestas: respuestas.
	^respuestas! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/7/2005 10:26'!
startRespuesta: attributeList 
	| respuesta |
	
	self top class = Hueco | (self top class = GeneradorHuecos)
		ifTrue: [^ self top]
		ifFalse: [respuesta := Respuesta new.
			self top add: respuesta.
			^ respuesta]! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/7/2005 10:10'!
startTexto: attributeList 
	| texto |
	self top class = Hueco
		ifTrue: [texto := self top]
		ifFalse: [texto := String new].
	^ texto! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/4/2005 21:26'!
textoPregunta: attributeList 
	| enunciado |
	
	enunciado := String new.
	^ enunciado! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 3/29/2005 21:25'!
top
	"answer the top most object on the stack"
	^ self stack isEmpty
		ifFalse: [self stack last]! !

!ParserEjercicios methodsFor: 'private' stamp: 'jlrr 5/7/2005 10:27'!
verdadera: attributeList 
	
	self top class = GeneradorHuecos | (self top class = Hueco)
		ifTrue: [^ self top]
		ifFalse: [^ false]! !


!ParserEjercicios methodsFor: 'accessing' stamp: 'jlrr 3/29/2005 20:29'!
coleccion
^coleccion! !

!ParserEjercicios methodsFor: 'accessing' stamp: 'jlrr 3/29/2005 21:33'!
stack
"answer the receiver's stack"
	^ stack! !


!ParserEjercicios methodsFor: 'content' stamp: 'jlrr 5/7/2005 10:38'!
endDocument
	
	super endDocument! !

!ParserEjercicios methodsFor: 'content' stamp: 'jlrr 3/29/2005 21:42'!
endElement: elementName 
	self pop.! !

!ParserEjercicios methodsFor: 'content' stamp: 'jlrr 3/29/2005 21:42'!
endElement: localName namespace: namespace namespaceURI: uri qualifiedName: qualifiedName 
	self endElement: localName! !

!ParserEjercicios methodsFor: 'content' stamp: 'jlrr 3/30/2005 19:49'!
startDocument
	super startDocument.
	""
	self push: self document! !

!ParserEjercicios methodsFor: 'content' stamp: 'jlrr 5/7/2005 11:36'!
startElement: elementName attributeList: attributeList 
	| selectors |
	
	selectors := Dictionary new.
	"todos:"
	selectors at: 'text' put: #startTexto:.
	selectors at: 'data' put: #startEjercicio:.
	"parejas:"
	selectors at: 'pair' put: #startPareja:.
	selectors at: 'left-item' put: #startIzquierdo:.
	selectors at: 'right-item' put: #startDerecho:.
	"huecos:"
	selectors at: 'gap-fill' put: #startEjercicioHuecos:.
	"preguntas y huecos:"
	selectors at: 'question-record' put: #startPregunta:.
	selectors at: 'answer' put: #startRespuesta:.
	"preguntas:"
	selectors at: 'question' put: #textoPregunta:.
	selectors at: 'answers' put: #startRespuestas:.
	selectors at: 'correct' put: #verdadera:.
	selectors
		at: elementName
		ifPresent: [:selector | 
			self
				push: (self perform: selector with: attributeList).
			^ self].
	self push: self top! !

!ParserEjercicios methodsFor: 'content' stamp: 'jlrr 3/29/2005 20:31'!
startElement: localName namespaceURI: namespaceUri namespace: namespace attributeList: attributeList 
	^ self startElement: localName attributeList: attributeList! !


!ParserEjercicios methodsFor: 'initialize' stamp: 'jlrr 5/4/2005 20:36'!
initialize
	super initialize.
	
	stack := OrderedCollection new.
tipo:=''! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ParserEjercicios class
	instanceVariableNames: ''!

!ParserEjercicios class methodsFor: 'initialize-release' stamp: 'jlrr 3/29/2005 21:31'!
parseStream: aStream 
| coleccion parser |
	coleccion := OrderedCollection new.
parser := self on: aStream.
			parser document: coleccion.

			parser startDocument.
			parser parseDocument.
	
	^ coleccion! !


PluggableTextMorph subclass: #PluggableTextForHuecos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!PluggableTextForHuecos methodsFor: 'accessing' stamp: 'jlrr 5/18/2005 20:21'!
setText: aText 
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := self textMorphClass new contents: aText wrappedTo: self innerBounds width - 6.
			textMorph setEditView: self.
			scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas! !

!PluggableTextForHuecos methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 18:15'!
textMorph
^textMorph! !


!PluggableTextForHuecos methodsFor: 'private' stamp: 'jlrr 4/27/2005 19:05'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^ TextoHuecos
	! !


Object subclass: #Pregunta
	instanceVariableNames: 'enunciado respuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!Pregunta methodsFor: 'accesing' stamp: 'jlrr 4/7/2005 21:21'!
addRespuesta: aRespuesta 
aRespuesta pregunta:self.
	respuestas add: aRespuesta! !

!Pregunta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:12'!
enunciado
	^enunciado! !

!Pregunta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:11'!
enunciado:aStringorText
enunciado:=aStringorText! !

!Pregunta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:13'!
respuestas
	^respuestas! !

!Pregunta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:12'!
respuestas:aCollection
	respuestas:=aCollection! !

!Pregunta methodsFor: 'accesing' stamp: 'jlrr 4/10/2005 09:55'!
texto: aStringorText 
	enunciado := aStringorText! !


!Pregunta methodsFor: 'initialization' stamp: 'jlrr 4/5/2005 20:21'!
initialize
	respuestas := OrderedCollection new.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Pregunta class
	instanceVariableNames: ''!

!Pregunta class methodsFor: 'class initialization' stamp: 'jlrr 4/7/2005 21:33'!
enunciado: aStringOrText 
	^self new enunciado: aStringOrText! !


EToyCommunicatorMorph subclass: #Profesor
	instanceVariableNames: 'recipients incomingRow recipientRow updateCounter'
	classVariableNames: 'FridgeRecipients NewItems TheFridgeForm UpdateCounter'
	poolDictionaries: ''
	category: 'Classroom'!

!Profesor methodsFor: 'dropping/grabbing' stamp: 'jlrr 5/7/2005 21:07'!
acceptDroppingMorph: morphToDrop event: evt 
	| outData |
	(morphToDrop isKindOf: NewHandleMorph)
		ifTrue: ["don't send these"
			^ morphToDrop rejectDropMorphEvent: evt].
	self eToyRejectDropMorph: morphToDrop event: evt.
	self stopFlashing.
	outData := morphToDrop eToyStreamedRepresentationNotifying: self.
	self resetIndicator: #working.
	self class fridgeRecipients
		do: [:each | self transmitStreamedObject: outData to: each ipAddress]! !

!Profesor methodsFor: 'dropping/grabbing' stamp: 'jlrr 5/7/2005 19:52'!
wantsDroppedMorph: aMorph event: evt

	^true! !


!Profesor methodsFor: 'initialization' stamp: 'jlrr 5/7/2005 19:52'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #raised! !

!Profesor methodsFor: 'initialization' stamp: 'jlrr 5/7/2005 19:52'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 4! !

!Profesor methodsFor: 'initialization' stamp: 'jlrr 5/7/2005 19:52'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color paleRed! !

!Profesor methodsFor: 'initialization' stamp: 'jlrr 5/12/2005 16:52'!
initialize
	"initialize the state of the receiver"
	| receptor |
	super initialize.
	""
	"Clean all the old previous connections:"
	Profesor fridgeRecipients
		collect: [:each | Profesor removeRecipientWithIPAddress: each ipAddress].
	
	""
	receptor := Alumno profesor.
	self addMorph: receptor.
	receptor visible: false.
	self listDirection: #topToBottom;
		 layoutInset: 10;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 setProperty: #normalBorderColor toValue: self borderColor;
		 setProperty: #flashingColors toValue: {Color red. Color yellow};
		 rebuild;
		 stopStepping! !


!Profesor methodsFor: 'drawing' stamp: 'jlrr 5/7/2005 19:52'!
drawOn: aCanvas

	| f cache |
	f _ self class fridgeForm ifNil: [^super drawOn: aCanvas].
	cache _ Form extent: bounds extent depth: aCanvas depth.
	f
		displayInterpolatedIn: cache boundingBox truncated
		on: cache.
	cache replaceColor: Color black withColor: Color transparent.
	aCanvas 
		translucentImage: cache
		at: bounds origin.
! !


!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
handlesMouseOverDragging: globalEvt

	^true! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
handlesMouseOver: globalEvt

	^true! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
mouseEnterDragging: evt

	^self mouseEnterEither: evt
! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 21:32'!
mouseEnterEither: evt 
	evt hand hasSubmorphs
		ifFalse: [^ self
				addMouseActionIndicatorsWidth: 10
				color: (Color blue alpha: 0.3)].
	(evt hand firstSubmorph isKindOf: EToySenderMorph)
		ifTrue: [^ self
				addMouseActionIndicatorsWidth: 10
				color: (Color magenta alpha: 0.3)].
	self
		addMouseActionIndicatorsWidth: 10
		color: (Color green alpha: 0.3)! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
mouseEnter: evt

	^self mouseEnterEither: evt
! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
mouseLeaveDragging: evt

	^self mouseLeaveEither: evt
! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 21:32'!
mouseLeaveEither: evt 
	self deleteAnyMouseActionIndicators! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
mouseLeave: evt

	^self mouseLeaveEither: evt
! !

!Profesor methodsFor: 'event handling' stamp: 'jlrr 5/7/2005 19:52'!
mouseUp: localEvt

	(self containsPoint: localEvt cursorPoint) ifFalse: [^self].
	Project enterIfThereOrFind: 'Fridge'! !


!Profesor methodsFor: 'private' stamp: 'jlrr 5/8/2005 21:57'!
nameForAddress: aNetworkAddress 
	| name |
	name := NetNameResolver nameForAddress: aNetworkAddress timeout: 10.

	name = 'localhost'
		ifTrue: [^Alumno debianAddress].
	name
		ifNil: [^ NetNameResolver stringFromAddress: aNetworkAddress]
		ifNotNil: [^ (name findTokens: '.')
				at: 1]! !

!Profesor methodsFor: 'private' stamp: 'jlrr 5/8/2005 11:04'!
nameForString: aString 
	| networkAddress name |
	networkAddress := NetNameResolver addressFromString: aString.
	name := self nameForAddress: networkAddress.
	aString = name
		ifTrue: [^ aString]
		ifFalse: [^ name]! !

!Profesor methodsFor: 'private' stamp: 'jlrr 5/18/2005 18:30'!
rebuild
	| row filler fudge people maxPerRow insetY address |
	updateCounter := self class updateCounter.
	self removeAllMorphs.
	(self addARow: {filler := Morph new color: Color transparent;
					 extent: 4 @ 4})
		vResizing: #shrinkWrap.
	
	address := NetNameResolver localAddressString.
	address = '127.0.0.1'
		ifTrue: [address := Alumno debianAddress].
	self addARow: {(StringMorph contents: 'Teacher: ' translated , address) color: Color blue;
			 lock}.
	self addARow: {(Morph new extent: 10 @ 10)
			color: Color transparent}.
	self addARow: {(StringMorph contents: 'Students list:' translated) emphasis: 1;
			 lock}.
	row := self addARow: {}.
	people := self class fridgeRecipients.
	maxPerRow := people size < 7
				ifTrue: [4]
				ifFalse: [6].
	"how big can this get before we need a different approach?"
	people
		do: [:each | 
			row submorphCount >= maxPerRow
				ifTrue: [row := self addARow: {}].
			row addMorphBack: (self nameForString: each ipAddress) asMorph lock.
			row
				addMorphBack: ((Morph new extent: 10 @ 1)
						color: Color transparent)].
	fullBounds := nil.
	self fullBounds.
	"htsBefore _ submorphs collect: [ :each | each height]."
	fudge := 20.
	insetY := self layoutInset.
	insetY isPoint
		ifTrue: [insetY := insetY y].
	filler extent: 4 @ (self height - filler height * 0.37 - insetY - borderWidth - fudge) truncated! !

!Profesor methodsFor: 'private' stamp: 'jlrr 5/18/2005 19:27'!
rebuild: aString 
	"little trick to make the teacher rebuild when picked up from a flap"
	self rebuild.
self openInHand.! !

!Profesor methodsFor: 'private' stamp: 'jlrr 5/8/2005 17:27'!
transmittedObjectCategory
	^ Receptor typeMorph! !

!Profesor methodsFor: 'private' stamp: 'jlrr 5/7/2005 21:32'!
trulyFlashIndicator: aSymbol 
	| state |
	state := (self
				valueOfProperty: #fridgeFlashingState
				ifAbsent: [false]) not.
	self setProperty: #fridgeFlashingState toValue: state.
	self
		addMouseActionIndicatorsWidth: 15
		color: (Color green
				alpha: (state
						ifTrue: [0.3]
						ifFalse: [0.7])).
	Beeper beep! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Profesor class
	instanceVariableNames: ''!

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
addRecipient: aSenderMorph

	self fridgeRecipients do: [ :each |
		aSenderMorph ipAddress = each ipAddress ifTrue: [^self]
	].
	self fridgeRecipients add: aSenderMorph.
	UpdateCounter _ self updateCounter + 1
! !

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
fridgeForm

	| fridgeFileName |

	fridgeFileName _ 'fridge.form'.
	TheFridgeForm ifNotNil: [^TheFridgeForm].
	(FileDirectory default fileExists: fridgeFileName) ifFalse: [^nil].
	^TheFridgeForm _ Form fromFileNamed: fridgeFileName.! !

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
fridgeRecipients

	^FridgeRecipients ifNil: [FridgeRecipients _ OrderedCollection new]! !

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
newItems

	^NewItems ifNil: [NewItems _ OrderedCollection new]! !

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
newItem: newMorph

	| theFridge fridgeWorld trialRect |

	theFridge _ Project named: 'Fridge'.
	theFridge ifNil: [^self newItems add: newMorph].
	fridgeWorld _ theFridge world.
	trialRect _ fridgeWorld randomBoundsFor: newMorph.
	fridgeWorld 
		addMorphFront: (newMorph position: trialRect topLeft);
		startSteppingSubmorphsOf: newMorph
! !

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
removeRecipientWithIPAddress: ipString

	FridgeRecipients _ self fridgeRecipients reject: [ :each |
		ipString = each ipAddress
	].
	UpdateCounter _ self updateCounter + 1
! !

!Profesor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/7/2005 19:52'!
updateCounter

	^UpdateCounter ifNil: [0]! !


!Profesor class methodsFor: 'parts bin' stamp: 'jlrr 5/7/2005 19:52'!
descriptionForPartsBin

	^ self partName: 	'Fridge'
		categories:		#('Collaborative')
		documentation:	'A tool for sending objects to other Squeak uers'! !



EToyIncomingMessage subclass: #Receptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!Receptor methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 18:44'!
incomingMessgage: dataStream fromIPAddress: ipAddress 
	| nullChar messageType senderName selectorAndReceiver |
	nullChar := 0 asCharacter.
	messageType := dataStream upTo: nullChar.
	senderName := dataStream upTo: nullChar.
	
	(EToyGateKeeperMorph
			acceptRequest: messageType
			from: senderName
			at: ipAddress)
		ifFalse: [^ self].
	selectorAndReceiver := self class messageHandlers
				at: messageType
				ifAbsent: [^ self].
	^ selectorAndReceiver second perform: selectorAndReceiver first withArguments: {dataStream. senderName. ipAddress}! !


!Receptor methodsFor: 'initialization' stamp: 'jlrr 5/12/2005 16:53'!
initialize
	super initialize.
	"This is necessary only the first time this class is executed:"
	(Receptor allTypes includes: 'typeAddress')
		ifFalse: [Receptor registerType: 'typeAddress'.
			EToyIncomingMessage registerType: 'typeAddress'.
			EToyGateKeeperEntry allInstances
				collect: [:each | each initialize].
			Receptor initializeMessageHandlers].
	"To avoid appearing of login message:"
	Utilities authorName: 'Classroom'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Receptor class
	instanceVariableNames: ''!

!Receptor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 19:28'!
handleNewAddressFrom: dataStream sentBy: senderName ipAddress: ipAddressString 
	| newObject newAlumno |
	newObject := self newObjectFromStream: dataStream.
	newAlumno := EToySenderMorph new
				userName: 'Student'
				userPicture: nil
				userEmail: nil
				userIPAddress: newObject contents.
	Profesor addRecipient: newAlumno.
Profesor allInstances collect:[:each| each rebuild].! !

!Receptor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/8/2005 21:58'!
handleNewMorphFrom: dataStream sentBy: senderName ipAddress: ipAddressString 
	| newObject targetWorld |
	
	newObject := self newObjectFromStream: dataStream.
	EToyCommunicatorMorph playArrivalSound.
	targetWorld := self currentWorld.
	newObject
		position: (newObject
				valueOfProperty: #positionInOriginatingWorld
				ifAbsent: [(targetWorld randomBoundsFor: newObject) topLeft]).
	WorldState addDeferredUIMessage: [newObject openInWorld: targetWorld] fixTemps! !

!Receptor class methodsFor: 'as yet unclassified' stamp: 'jlrr 5/12/2005 13:14'!
initializeMessageHandlers
	self
		forType: self typeMorph
		send: #handleNewMorphFrom:sentBy:ipAddress:
		to: self;
		forType:'typeAddress'
		send:#handleNewAddressFrom:sentBy:ipAddress:
		to: self;
		forType: self typeFridge
		send: #handleNewFridgeMorphFrom:sentBy:ipAddress:
		to: self;
		
		forType: self typeKeyboardChat
		send: #handleNewChatFrom:sentBy:ipAddress:
		to: self;
		
		forType: self typeMultiChat
		send: #handleNewMultiChatFrom:sentBy:ipAddress:
		to: self;
		
		forType: self typeStatusRequest
		send: #handleNewStatusRequestFrom:sentBy:ipAddress:
		to: self;
		
		forType: self typeStatusReply
		send: #handleNewStatusReplyFrom:sentBy:ipAddress:
		to: self;
		
		forType: self typeSeeDesktop
		send: #handleNewSeeDesktopFrom:sentBy:ipAddress:
		to: self! !


ScrollPane subclass: #ReceptorHuecos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!ReceptorHuecos methodsFor: 'drag and drop' stamp: 'jlrr 5/4/2005 19:54'!
acceptDroppingMorph: transferMorph event: evt 
	| srcType success hueco |
	success := false.
	transferMorph class = TransferMorph
		ifTrue: ["Here we are fetching informations from the dropped
			transferMorph 
			and 
			performing the correct action for this drop."
			srcType := transferMorph dragTransferType.
			hueco := transferMorph passenger.
			srcType == #hueco
				ifTrue: [self addMorph: hueco.
					hueco receptor: self;
					textPosition: hueco position - self position]].
	^ success! !


!ReceptorHuecos methodsFor: 'accessing' stamp: 'jlrr 4/28/2005 17:20'!
huecos
	^
	self
		submorphsSatisfying: [:each | each class = Hueco]! !


!ReceptorHuecos methodsFor: 'initialization' stamp: 'jlrr 4/28/2005 18:44'!
initialize
	super initialize.
	self enableDrop: true;
		 color: Color lightYellow;

		 hideScrollBarsIndefinitely;
		 borderWidth: 1! !


Object subclass: #Respuesta
	instanceVariableNames: 'enunciado marcada verdadera pregunta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!Respuesta methodsFor: 'drawing' stamp: 'jlrr 4/9/2005 19:23'!
editaPreguntaAncho: aPoint 
	| contenedor texto boton |
	contenedor := AlignmentMorphBob1 newRow.
	texto := PluggableTextMorph 
				on: self
				text: #enunciado
				accept: #enunciado:
				readSelection: nil
				menu: nil.
	texto
		borderWidth: 1;
		color: Color white;
		acceptOnCR: true;
		vShowScrollBar;
		askBeforeDiscardingEdits: true;
		hideHScrollBarIndefinitely: true;
		extent: aPoint.
	contenedor addMorph: texto.
	boton := (BotonOpciones new)
				target: self;
				actionSelector: #verdadera:.
	verdadera ifTrue: [boton ponerX].
	contenedor addMorph: boton.
	contenedor
		extent: aPoint;
		borderWidth: 0.
	^contenedor! !

!Respuesta methodsFor: 'drawing' stamp: 'jlrr 4/8/2005 17:37'!
pintaPreguntaAncho: aPoint 
	| contenedor texto boton |
	contenedor := AlignmentMorphBob1 newRow.
	contenedor
		extent: aPoint;
		borderWidth: 0.
	texto := TextMorph new contentsWrapped: self enunciado.
	texto extent: contenedor bounds corner.
	contenedor addMorph: texto.
	boton := (BotonOpciones new)
				target: self;
				actionSelector: #marcada:.
marcada ifTrue:[boton ponerX].
	contenedor addMorph: boton.
	^contenedor! !


!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:19'!
enunciado
^enunciado! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:19'!
enunciado:aStringOrText
enunciado:=aStringOrText! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:19'!
marcada
^marcada! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:18'!
marcada:aBoolean
marcada:=aBoolean! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:23'!
pregunta
^pregunta! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:23'!
pregunta:aPregunta
pregunta:=aPregunta! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/10/2005 19:51'!
texto: aStringOrText 
	
	enunciado := aStringOrText! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:20'!
verdadera
^verdadera ! !

!Respuesta methodsFor: 'accesing' stamp: 'jlrr 4/5/2005 20:20'!
verdadera:aBoolean
verdadera:=aBoolean! !


!Respuesta methodsFor: 'initialization' stamp: 'jlrr 4/7/2005 19:08'!
initialize
	marcada := false.
verdadera:=false.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Respuesta class
	instanceVariableNames: ''!

!Respuesta class methodsFor: 'class initialization' stamp: 'jlrr 4/7/2005 21:33'!
enunciado: aStringOrText es: aBoolean 
	^(self new)
		enunciado: aStringOrText;
		verdadera: aBoolean! !


TextMorph subclass: #TextoHuecos
	instanceVariableNames: 'editView locked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Classroom'!

!TextoHuecos methodsFor: 'editing' stamp: 'jlrr 4/27/2005 19:06'!
acceptContents
	"The message is sent when the user hits enter or Cmd-S.
	Accept the current contents and end editing."
	self updateFromParagraph.
	editView accept! !


!TextoHuecos methodsFor: 'event handling' stamp: 'jlrr 4/27/2005 19:07'!
autoScrollView: evt 
	"This is kind of a hack because the PluggableTextMorph
	expects me to first expand the selection before auto scrolling
	will work."
	| localEvt |
	localEvt := evt
				transformedBy: (self transformedFrom: editView).
	super mouseMove: localEvt.
	editView scrollSelectionIntoView: localEvt! !

!TextoHuecos methodsFor: 'event handling' stamp: 'jlrr 4/25/2005 21:53'!
mouseDown: evt 
	"Make this TextMorph be the keyboard input focus, if it isn't
	already, and repond to the text selection gesture."
	evt hand newKeyboardFocus: self.
	
	self
		handleInteraction: [editor mouseDown: evt]
		fromEvent: evt! !


!TextoHuecos methodsFor: 'private' stamp: 'jlrr 4/27/2005 19:10'!
editorClass
	"Answer the class used to create the receiver's editor"
	^ EjercicioHuecosEditor! !

!TextoHuecos methodsFor: 'private' stamp: 'jlrr 4/28/2005 18:24'!
installEditorToReplace: priorEditor 
	"Install an editor for my paragraph. This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its
	state. We may want to rework this so it actually uses the prior
	editor."
	| stateArray |
	priorEditor
		ifNotNil: [stateArray := priorEditor stateArray].
	editor := self editorClass new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor
		ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	
	^ editor! !

!TextoHuecos methodsFor: 'private' stamp: 'jlrr 4/27/2005 21:37'!
updateFromParagraph
	super updateFromParagraph.
	editView ifNotNil:[editView setScrollDeltas]! !


!TextoHuecos methodsFor: 'edit view' stamp: 'jlrr 4/27/2005 19:05'!
editView
	^ editView! !

!TextoHuecos methodsFor: 'edit view' stamp: 'jlrr 4/28/2005 19:37'!
locked
	^ locked! !

!TextoHuecos methodsFor: 'edit view' stamp: 'jlrr 4/28/2005 18:20'!
locked: aBoolean.
	^ locked:=aBoolean.! !

!TextoHuecos methodsFor: 'edit view' stamp: 'jlrr 4/27/2005 19:06'!
setEditView: editPane 
	editView := editPane! !


!TextoHuecos methodsFor: 'as yet unclassified' stamp: 'jlrr 4/28/2005 18:20'!
initialize
super initialize.
locked:=false.! !

Alumno initialize!
ElementoParejas initialize!
Hueco initialize!